/**************************************************************************************************
  LED.c
  Support for the red, green, and blue LEDs of the Tiva board.
  The red LED is wired to PD2.
  The green LED is wired to PD3.
  The blue LED is wired to PD5.
**************************************************************************************************/

// Include Files
#include "LED.h"
#include "Buffers.h"



// LED connections
sbit LED_R                     at GPIO_PORTD_AHB_DATA.B2;
sbit LED_G                     at GPIO_PORTD_AHB_DATA.B3;
sbit LED_B                     at GPIO_PORTD_AHB_DATA.B5;
sbit LED_R_Direction           at GPIO_PORTD_AHB_DIR.B2;
sbit LED_G_Direction           at GPIO_PORTD_AHB_DIR.B3;
sbit LED_B_Direction           at GPIO_PORTD_AHB_DIR.B5;


// Variables



/**************************************************************************************************
  LED_Initialize */
void LED_Initialize(void) {
       // Make port pins outputs
     GPIO_Digital_Output(&GPIO_PORTD_AHB, _GPIO_PINMASK_2 | _GPIO_PINMASK_3 | _GPIO_PINMASK_5);
}

/**************************************************************************************************
  LED_Set_Red */
void LED_Set_Red(void) {
     LED_R = 1;
}

/**************************************************************************************************
  LED_Clear_Red */
void LED_Clr_Red(void) {
     LED_R = 0;
}

/**************************************************************************************************
  LED_Set_Green */
void LED_Set_Green(void) {
     LED_G = 1;
}

/**************************************************************************************************
  LED_Clear_Green */
void LED_Clr_Green(void) {
     LED_G = 0;
}

/**************************************************************************************************
  LED_Set_Blue */
void LED_Set_Blue(void) {
     LED_B = 1;
}

/**************************************************************************************************
  LED_Clear_Blue */
void LED_Clr_Blue(void) {
     LED_B = 0;
}