#line 1 "C:/ARM Projects/Mikromedia 5 for Tiva/WiFi/Timers.c"
#line 1 "c:/arm projects/mikromedia 5 for tiva/wifi/timers.h"
#line 11 "c:/arm projects/mikromedia 5 for tiva/wifi/timers.h"
void TimerInit(void);
void TimerCheck(void);
#line 33 "c:/arm projects/mikromedia 5 for tiva/wifi/timers.h"
struct timers {
 unsigned long int TimerField;
 unsigned short int Free;
};
#line 45 "c:/arm projects/mikromedia 5 for tiva/wifi/timers.h"
void init_timerpool(void);
#line 54 "c:/arm projects/mikromedia 5 for tiva/wifi/timers.h"
unsigned short int get_timer(void);
#line 64 "c:/arm projects/mikromedia 5 for tiva/wifi/timers.h"
void set_timer(unsigned short int nbr, unsigned long int tout);
#line 73 "c:/arm projects/mikromedia 5 for tiva/wifi/timers.h"
unsigned long int check_timer(unsigned short int nbr);
#line 82 "c:/arm projects/mikromedia 5 for tiva/wifi/timers.h"
void free_timer(unsigned short int nbr);
#line 91 "c:/arm projects/mikromedia 5 for tiva/wifi/timers.h"
void irqhandler_timer(void);
#line 1 "c:/arm projects/mikromedia 5 for tiva/wifi/common.h"
#line 1 "c:/arm projects/mikromedia 5 for tiva/wifi/uart1.h"
#line 21 "c:/arm projects/mikromedia 5 for tiva/wifi/uart1.h"
typedef void (* tPointerFcn)(void);



void UART1_Enable(void);
void UART1_StartRx(void);
void UART1_StartTx(void);
char UART1_CheckFree(void);

void UART1_Initialize(void);
void UART1_RxQueueInit(void);
char UART1_GetChar(char *rxbyte);
void UART1_Rx(void);
void UART1_Rx1(void);
void UART1_Rx2(void);

void UART1_TxQueueInit(void);
void UART1_PutQueue(char *msg);
void UART1_SendMsg(char *s);
void UART1_Tx(void);
void UART1_Tx1(void);
void UART1_Send(char *s);
#line 13 "C:/ARM Projects/Mikromedia 5 for Tiva/WiFi/Timers.c"
int TimerFlag = 0;
unsigned int Msec = 0;
#line 26 "C:/ARM Projects/Mikromedia 5 for Tiva/WiFi/Timers.c"
void SystemTimerInterrupt() iv IVT_FAULT_SYSTICK ics ICS_AUTO {
 if (NVIC_ST_CTRL_COUNT_bit) {
 irqhandler_timer();

 Msec += 1;
 if (Msec > 999) {
 Msec = 0;
 TimerFlag = 1;
 }
 }
}
#line 40 "C:/ARM Projects/Mikromedia 5 for Tiva/WiFi/Timers.c"
void TimerInit(void) {
 init_timerpool();

 NVIC_ST_RELOAD = 119999;

 NVIC_ST_CURRENT = 0;
 NVIC_ST_CTRL_CLK_SRC_bit = 1;
 NVIC_ST_CTRL_INTEN_bit = 1;
 NVIC_ST_CTRL_ENABLE_bit = 1;
}
#line 53 "C:/ARM Projects/Mikromedia 5 for Tiva/WiFi/Timers.c"
void TimerCheck(void) {
 if (TimerFlag == 1) {
 TimerFlag = 0;

 }
}
#line 80 "C:/ARM Projects/Mikromedia 5 for Tiva/WiFi/Timers.c"
struct timers TimerPool[ 10 ];
#line 89 "C:/ARM Projects/Mikromedia 5 for Tiva/WiFi/Timers.c"
void init_timerpool(void) {
 unsigned short int i;

 for (i=0; i <  10 ; i++) {
 TimerPool[i].TimerField = 0;
 TimerPool[i].Free =  1 ;
 }
}
#line 104 "C:/ARM Projects/Mikromedia 5 for Tiva/WiFi/Timers.c"
unsigned short int get_timer(void) {
 unsigned short int i;

 for (i=0; i <  10 ; i++) {
 if (TimerPool[i].Free ==  1 ) {
 TimerPool[i].Free =  0 ;
 return i;
 }
 }


 UART1_PutQueue("TIMERS: No Timers, Resetting..\r\n");

 SystemReset();
 return (0);
}
#line 128 "C:/ARM Projects/Mikromedia 5 for Tiva/WiFi/Timers.c"
void set_timer(unsigned short int nbr, unsigned long int tout) {
 if (nbr > ( 10 -1))
 return;

 if (TimerPool[nbr].Free ==  1 )
 return;

 TimerPool[nbr].TimerField = tout;
}
#line 144 "C:/ARM Projects/Mikromedia 5 for Tiva/WiFi/Timers.c"
unsigned long int check_timer(unsigned short int nbr) {
 return TimerPool[nbr].TimerField;
}
#line 154 "C:/ARM Projects/Mikromedia 5 for Tiva/WiFi/Timers.c"
void free_timer(unsigned short int nbr) {
 if (nbr > ( 10 -1))
 return;

 TimerPool[nbr].Free =  1 ;
}
#line 167 "C:/ARM Projects/Mikromedia 5 for Tiva/WiFi/Timers.c"
void irqhandler_timer(void) {
 unsigned short int i;

 for (i=0; i< 10 ; i++) {
 if (TimerPool[i].Free ==  0  && TimerPool[i].TimerField != 0)
 TimerPool[i].TimerField--;
 }
}
