_UART1_Interrupt:
;UART1.c,70 :: 		void UART1_Interrupt() iv IVT_INT_UART1 ics ICS_AUTO {
;UART1.c,75 :: 		if (UART_FR_RXFF_UART1_FR_bit && UART_IM_RXIM_UART1_IM_bit) {
MOVW	R1, #lo_addr(UART_FR_RXFF_UART1_FR_bit+0)
MOVT	R1, #hi_addr(UART_FR_RXFF_UART1_FR_bit+0)
LDR	R0, [R1, #0]
CMP	R0, #0
IT	EQ
BEQ	L__UART1_Interrupt66
MOVW	R1, #lo_addr(UART_IM_RXIM_UART1_IM_bit+0)
MOVT	R1, #hi_addr(UART_IM_RXIM_UART1_IM_bit+0)
LDR	R0, [R1, #0]
CMP	R0, #0
IT	EQ
BEQ	L__UART1_Interrupt65
L__UART1_Interrupt64:
;UART1.c,78 :: 		R_data = UART1_DR;              // Get the byte from receive holding register
MOVW	R0, #lo_addr(UART1_DR+0)
MOVT	R0, #hi_addr(UART1_DR+0)
; R_data start address is: 12 (R3)
LDR	R3, [R0, #0]
;UART1.c,79 :: 		RxQueue[RxIn++] = R_data;       // Put data byte in re-circulating buffer, increment pointer
MOVW	R2, #lo_addr(_RxIn+0)
MOVT	R2, #hi_addr(_RxIn+0)
LDRB	R1, [R2, #0]
MOVW	R0, #lo_addr(_RxQueue+0)
MOVT	R0, #hi_addr(_RxQueue+0)
ADDS	R0, R0, R1
STRB	R3, [R0, #0]
; R_data end address is: 12 (R3)
MOV	R0, R2
LDRB	R0, [R0, #0]
ADDS	R0, R0, #1
UXTB	R0, R0
STRB	R0, [R2, #0]
;UART1.c,80 :: 		if (RxIn > (rxqsize-1))         // Adjust pointer if necessary
CMP	R0, #255
IT	LS
BLS	L_UART1_Interrupt3
;UART1.c,81 :: 		RxIn = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_RxIn+0)
MOVT	R0, #hi_addr(_RxIn+0)
STRB	R1, [R0, #0]
L_UART1_Interrupt3:
;UART1.c,75 :: 		if (UART_FR_RXFF_UART1_FR_bit && UART_IM_RXIM_UART1_IM_bit) {
L__UART1_Interrupt66:
L__UART1_Interrupt65:
;UART1.c,85 :: 		if (UART_FR_TXFE_UART1_FR_bit && UART_IM_TXIM_UART1_IM_bit) {
MOVW	R1, #lo_addr(UART_FR_TXFE_UART1_FR_bit+0)
MOVT	R1, #hi_addr(UART_FR_TXFE_UART1_FR_bit+0)
LDR	R0, [R1, #0]
CMP	R0, #0
IT	EQ
BEQ	L__UART1_Interrupt68
MOVW	R1, #lo_addr(UART_IM_TXIM_UART1_IM_bit+0)
MOVT	R1, #hi_addr(UART_IM_TXIM_UART1_IM_bit+0)
LDR	R0, [R1, #0]
CMP	R0, #0
IT	EQ
BEQ	L__UART1_Interrupt67
L__UART1_Interrupt63:
;UART1.c,87 :: 		T_data = XmtBuf[XmtBufPtr++];   // Get a byte from the transmit buffer
MOVW	R2, #lo_addr(_XmtBufPtr+0)
MOVT	R2, #hi_addr(_XmtBufPtr+0)
LDRB	R1, [R2, #0]
MOVW	R0, #lo_addr(_XmtBuf+0)
MOVT	R0, #hi_addr(_XmtBuf+0)
LDR	R0, [R0, #0]
ADDS	R0, R0, R1
LDRB	R1, [R0, #0]
; T_data start address is: 12 (R3)
UXTB	R3, R1
MOV	R0, R2
LDRB	R0, [R0, #0]
ADDS	R0, R0, #1
STRB	R0, [R2, #0]
;UART1.c,88 :: 		if (T_data == NUL) {            // If it is the end of message marker
CMP	R1, #0
IT	NE
BNE	L_UART1_Interrupt7
; T_data end address is: 12 (R3)
;UART1.c,89 :: 		UART_IM_TXIM_UART1_IM_bit = 0;   // Disable transmitter interrupts
MOVS	R1, #0
SXTB	R1, R1
MOVW	R0, #lo_addr(UART_IM_TXIM_UART1_IM_bit+0)
MOVT	R0, #hi_addr(UART_IM_TXIM_UART1_IM_bit+0)
STR	R1, [R0, #0]
;UART1.c,91 :: 		} else {
IT	AL
BAL	L_UART1_Interrupt8
L_UART1_Interrupt7:
;UART1.c,92 :: 		UART1_DR = T_data;          // Transfer data byte to transmit register
; T_data start address is: 12 (R3)
MOVW	R0, #lo_addr(UART1_DR+0)
MOVT	R0, #hi_addr(UART1_DR+0)
STR	R3, [R0, #0]
; T_data end address is: 12 (R3)
;UART1.c,93 :: 		}
L_UART1_Interrupt8:
;UART1.c,85 :: 		if (UART_FR_TXFE_UART1_FR_bit && UART_IM_TXIM_UART1_IM_bit) {
L__UART1_Interrupt68:
L__UART1_Interrupt67:
;UART1.c,95 :: 		}
L_end_UART1_Interrupt:
BX	LR
; end of _UART1_Interrupt
_UART1_Enable:
;UART1.c,100 :: 		void UART1_Enable(void) {
;UART1.c,102 :: 		SYSCTL_RCGCGPIO_R14_bit = 1;        // Enable and provide a clock to GPIO Port Q in Run mode.
MOVS	R2, #1
SXTB	R2, R2
MOVW	R0, #lo_addr(SYSCTL_RCGCGPIO_R14_bit+0)
MOVT	R0, #hi_addr(SYSCTL_RCGCGPIO_R14_bit+0)
STR	R2, [R0, #0]
;UART1.c,104 :: 		GPIO_PORTQ_DIR4_bit = 0;            // Set bit 4 as input (RX)
MOVS	R1, #0
SXTB	R1, R1
MOVW	R0, #lo_addr(GPIO_PORTQ_DIR4_bit+0)
MOVT	R0, #hi_addr(GPIO_PORTQ_DIR4_bit+0)
STR	R1, [R0, #0]
;UART1.c,105 :: 		GPIO_PORTQ_DIR5_bit = 1;            // Set bit 5 as output (TX)
MOVW	R0, #lo_addr(GPIO_PORTQ_DIR5_bit+0)
MOVT	R0, #hi_addr(GPIO_PORTQ_DIR5_bit+0)
STR	R2, [R0, #0]
;UART1.c,106 :: 		GPIO_PORTQ_AFSEL4_bit = 1;          // Alternate function for PQ4 (UART1-RX)
MOVW	R0, #lo_addr(GPIO_PORTQ_AFSEL4_bit+0)
MOVT	R0, #hi_addr(GPIO_PORTQ_AFSEL4_bit+0)
STR	R2, [R0, #0]
;UART1.c,107 :: 		GPIO_PORTQ_AFSEL5_bit = 1;          // Alternate function for PQ5 (UART1-TX)
MOVW	R0, #lo_addr(GPIO_PORTQ_AFSEL5_bit+0)
MOVT	R0, #hi_addr(GPIO_PORTQ_AFSEL5_bit+0)
STR	R2, [R0, #0]
;UART1.c,108 :: 		GPIO_PORTQ_PCTL |= 0x00110000;      // Select UART1 Rx and Tx
MOVW	R0, #lo_addr(GPIO_PORTQ_PCTL+0)
MOVT	R0, #hi_addr(GPIO_PORTQ_PCTL+0)
LDR	R0, [R0, #0]
ORR	R1, R0, #1114112
MOVW	R0, #lo_addr(GPIO_PORTQ_PCTL+0)
MOVT	R0, #hi_addr(GPIO_PORTQ_PCTL+0)
STR	R1, [R0, #0]
;UART1.c,109 :: 		GPIO_PORTQ_DEN |= 0x30;              // Enable PQ4 and PQ5 digital function
MOVW	R0, #lo_addr(GPIO_PORTQ_DEN+0)
MOVT	R0, #hi_addr(GPIO_PORTQ_DEN+0)
LDR	R0, [R0, #0]
ORR	R1, R0, #48
MOVW	R0, #lo_addr(GPIO_PORTQ_DEN+0)
MOVT	R0, #hi_addr(GPIO_PORTQ_DEN+0)
STR	R1, [R0, #0]
;UART1.c,111 :: 		SYSCTL_RCGCUART_R1_bit = 1;         // Enable and provide a clock to UART module 1 in Run mode.
MOVW	R0, #lo_addr(SYSCTL_RCGCUART_R1_bit+0)
MOVT	R0, #hi_addr(SYSCTL_RCGCUART_R1_bit+0)
STR	R2, [R0, #0]
;UART1.c,118 :: 		UART_CTL_UARTEN_UART1_CTL_bit = 1;  // Enable UART
MOVW	R0, #lo_addr(UART_CTL_UARTEN_UART1_CTL_bit+0)
MOVT	R0, #hi_addr(UART_CTL_UARTEN_UART1_CTL_bit+0)
STR	R2, [R0, #0]
;UART1.c,120 :: 		UART1_IBRD = 0x030D;                // Set integer portion
MOVW	R1, #781
MOVW	R0, #lo_addr(UART1_IBRD+0)
MOVT	R0, #hi_addr(UART1_IBRD+0)
STR	R1, [R0, #0]
;UART1.c,121 :: 		UART1_FBRD = 0x10;                  // Set fraction portion
MOVS	R1, #16
MOVW	R0, #lo_addr(UART1_FBRD+0)
MOVT	R0, #hi_addr(UART1_FBRD+0)
STR	R1, [R0, #0]
;UART1.c,122 :: 		UART1_LCRH = 0x60;                  // 8-bit data, 1-bit stop, no parity
MOVS	R1, #96
MOVW	R0, #lo_addr(UART1_LCRH+0)
MOVT	R0, #hi_addr(UART1_LCRH+0)
STR	R1, [R0, #0]
;UART1.c,124 :: 		UART_CTL_TXE_UART1_CTL_bit = 1;     // This bit should already be on after reset
MOVW	R0, #lo_addr(UART_CTL_TXE_UART1_CTL_bit+0)
MOVT	R0, #hi_addr(UART_CTL_TXE_UART1_CTL_bit+0)
STR	R2, [R0, #0]
;UART1.c,125 :: 		UART_CTL_RXE_UART1_CTL_bit = 1;     // This bit should already be on after reset
MOVW	R0, #lo_addr(UART_CTL_RXE_UART1_CTL_bit+0)
MOVT	R0, #hi_addr(UART_CTL_RXE_UART1_CTL_bit+0)
STR	R2, [R0, #0]
;UART1.c,127 :: 		UART_ICR_RXIC_UART1_ICR_bit = 1;    // Clear raw interrupt
MOVW	R0, #lo_addr(UART_ICR_RXIC_UART1_ICR_bit+0)
MOVT	R0, #hi_addr(UART_ICR_RXIC_UART1_ICR_bit+0)
STR	R2, [R0, #0]
;UART1.c,130 :: 		NVIC_EN0_INT6_bit = 1;              // Enable UART1 interrupts
MOVW	R1, #lo_addr(NVIC_EN0_INT6_bit+0)
MOVT	R1, #hi_addr(NVIC_EN0_INT6_bit+0)
LDR	R0, [R1, #0]
BFI	R0, R2, BitPos(NVIC_EN0_INT6_bit+0), #1
STR	R0, [R1, #0]
;UART1.c,131 :: 		UART1_DR = 0x00;                    // Kick start the transmitter. Don't know why this is necessary.
MOVS	R1, #0
MOVW	R0, #lo_addr(UART1_DR+0)
MOVT	R0, #hi_addr(UART1_DR+0)
STR	R1, [R0, #0]
;UART1.c,132 :: 		}
L_end_UART1_Enable:
BX	LR
; end of _UART1_Enable
_UART1_StartRx:
;UART1.c,137 :: 		void UART1_StartRx(void) {
;UART1.c,138 :: 		UART_IM_RXIM_UART1_IM_bit = 1;      // Enable receiver interrupts
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(UART_IM_RXIM_UART1_IM_bit+0)
MOVT	R0, #hi_addr(UART_IM_RXIM_UART1_IM_bit+0)
STR	R1, [R0, #0]
;UART1.c,139 :: 		}
L_end_UART1_StartRx:
BX	LR
; end of _UART1_StartRx
_UART1_StartTx:
;UART1.c,144 :: 		void UART1_StartTx(void) {
;UART1.c,145 :: 		UART_IM_TXIM_UART1_IM_bit = 1;      // Enable transmitter interrupts
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(UART_IM_TXIM_UART1_IM_bit+0)
MOVT	R0, #hi_addr(UART_IM_TXIM_UART1_IM_bit+0)
STR	R1, [R0, #0]
;UART1.c,146 :: 		}
L_end_UART1_StartTx:
BX	LR
; end of _UART1_StartTx
_UART1_CheckFree:
;UART1.c,151 :: 		char UART1_CheckFree(void) {
;UART1.c,152 :: 		if (UART_IM_TXIM_UART1_IM_bit)     // UART is busy if transmitter interrupts are enabled
MOVW	R1, #lo_addr(UART_IM_TXIM_UART1_IM_bit+0)
MOVT	R1, #hi_addr(UART_IM_TXIM_UART1_IM_bit+0)
LDR	R0, [R1, #0]
CMP	R0, #0
IT	EQ
BEQ	L_UART1_CheckFree9
;UART1.c,153 :: 		return 0;
MOVS	R0, #0
IT	AL
BAL	L_end_UART1_CheckFree
L_UART1_CheckFree9:
;UART1.c,155 :: 		return 1;
MOVS	R0, #1
;UART1.c,156 :: 		}
L_end_UART1_CheckFree:
BX	LR
; end of _UART1_CheckFree
_UART1_Initialize:
;UART1.c,165 :: 		void UART1_Initialize(void) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;UART1.c,166 :: 		UART1_RxQueueInit();                // Set up receiver queue pointers
BL	_UART1_RxQueueInit+0
;UART1.c,167 :: 		UART1_TxQueueInit();                // Set up transmitter queue pointers
BL	_UART1_TxQueueInit+0
;UART1.c,169 :: 		UART1_Enable();                     // Do hardware enabling
BL	_UART1_Enable+0
;UART1.c,170 :: 		UART1_StartRx();                    // Start the receiver
BL	_UART1_StartRx+0
;UART1.c,171 :: 		}
L_end_UART1_Initialize:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _UART1_Initialize
_UART1_RxQueueInit:
;UART1.c,177 :: 		void UART1_RxQueueInit(void) {
;UART1.c,178 :: 		RxIn = RxOut = 0;                 // Set pointers to 0
MOVS	R1, #0
MOVW	R0, #lo_addr(_RxOut+0)
MOVT	R0, #hi_addr(_RxOut+0)
STRB	R1, [R0, #0]
MOVS	R1, #0
MOVW	R0, #lo_addr(_RxIn+0)
MOVT	R0, #hi_addr(_RxIn+0)
STRB	R1, [R0, #0]
;UART1.c,179 :: 		RcvBufPtr = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_RcvBufPtr+0)
MOVT	R0, #hi_addr(_RcvBufPtr+0)
STRB	R1, [R0, #0]
;UART1.c,180 :: 		}
L_end_UART1_RxQueueInit:
BX	LR
; end of _UART1_RxQueueInit
_UART1_GetChar:
;UART1.c,187 :: 		char UART1_GetChar(char *rxbyte) {
; rxbyte start address is: 0 (R0)
; rxbyte end address is: 0 (R0)
; rxbyte start address is: 0 (R0)
;UART1.c,188 :: 		if (RxIn != RxOut) {              // If there is a character in the buffer
MOVW	R1, #lo_addr(_RxOut+0)
MOVT	R1, #hi_addr(_RxOut+0)
LDRB	R2, [R1, #0]
MOVW	R1, #lo_addr(_RxIn+0)
MOVT	R1, #hi_addr(_RxIn+0)
LDRB	R1, [R1, #0]
CMP	R1, R2
IT	EQ
BEQ	L_UART1_GetChar11
;UART1.c,189 :: 		*rxbyte = RxQueue[RxOut++];    // Extract the character and update the pointer
MOVW	R3, #lo_addr(_RxOut+0)
MOVT	R3, #hi_addr(_RxOut+0)
LDRB	R2, [R3, #0]
MOVW	R1, #lo_addr(_RxQueue+0)
MOVT	R1, #hi_addr(_RxQueue+0)
ADDS	R1, R1, R2
LDRB	R1, [R1, #0]
STRB	R1, [R0, #0]
; rxbyte end address is: 0 (R0)
MOV	R1, R3
LDRB	R1, [R1, #0]
ADDS	R1, R1, #1
UXTB	R1, R1
STRB	R1, [R3, #0]
;UART1.c,190 :: 		if (RxOut > (rxqsize-1))       // Check for wrap
CMP	R1, #255
IT	LS
BLS	L_UART1_GetChar12
;UART1.c,191 :: 		RxOut = 0;
MOVS	R2, #0
MOVW	R1, #lo_addr(_RxOut+0)
MOVT	R1, #hi_addr(_RxOut+0)
STRB	R2, [R1, #0]
L_UART1_GetChar12:
;UART1.c,192 :: 		return 1;
MOVS	R0, #1
IT	AL
BAL	L_end_UART1_GetChar
;UART1.c,193 :: 		}else{
L_UART1_GetChar11:
;UART1.c,194 :: 		return 0;                      // No data available
MOVS	R0, #0
;UART1.c,196 :: 		}
L_end_UART1_GetChar:
BX	LR
; end of _UART1_GetChar
_UART1_Rx:
;UART1.c,201 :: 		void UART1_Rx(void) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;UART1.c,202 :: 		UART1_RxFuncPtr();    // Use the function pointer to go to a state
MOVW	R4, #lo_addr(_UART1_RxFuncPtr+0)
MOVT	R4, #hi_addr(_UART1_RxFuncPtr+0)
LDR	R4, [R4, #0]
BLX	R4
;UART1.c,203 :: 		}
L_end_UART1_Rx:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _UART1_Rx
_UART1_Rx1:
;UART1.c,209 :: 		void UART1_Rx1(void) {
SUB	SP, SP, #8
STR	LR, [SP, #0]
;UART1.c,212 :: 		if (UART1_GetChar(&rxchar)) {
ADD	R0, SP, #4
BL	_UART1_GetChar+0
CMP	R0, #0
IT	EQ
BEQ	L_UART1_Rx114
;UART1.c,213 :: 		switch (rxchar) {
IT	AL
BAL	L_UART1_Rx115
;UART1.c,215 :: 		case NUL:         // Discard NUL character
L_UART1_Rx117:
;UART1.c,216 :: 		break;
IT	AL
BAL	L_UART1_Rx116
;UART1.c,218 :: 		case '\r':        // Discard return character
L_UART1_Rx118:
;UART1.c,219 :: 		break;
IT	AL
BAL	L_UART1_Rx116
;UART1.c,221 :: 		case '\n':
L_UART1_Rx119:
;UART1.c,222 :: 		RcvBuf[RcvBufPtr++] = rxchar;       // Put received character into buffer
MOVW	R2, #lo_addr(_RcvBufPtr+0)
MOVT	R2, #hi_addr(_RcvBufPtr+0)
LDRB	R1, [R2, #0]
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
ADDS	R1, R0, R1
LDRB	R0, [SP, #4]
STRB	R0, [R1, #0]
MOV	R0, R2
LDRB	R0, [R0, #0]
ADDS	R1, R0, #1
UXTB	R1, R1
STRB	R1, [R2, #0]
;UART1.c,223 :: 		RcvBuf[RcvBufPtr] = 0;              // End marker
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
ADDS	R1, R0, R1
MOVS	R0, #0
STRB	R0, [R1, #0]
;UART1.c,224 :: 		RcvBufPtr = 0;                      // Point to start of buffer
MOVS	R0, #0
STRB	R0, [R2, #0]
;UART1.c,225 :: 		UART1_RxFuncPtr = UART1_Rx2;        // Go to state 2
MOVW	R1, #lo_addr(_UART1_Rx2+0)
MOVT	R1, #hi_addr(_UART1_Rx2+0)
MOVW	R0, #lo_addr(_UART1_RxFuncPtr+0)
MOVT	R0, #hi_addr(_UART1_RxFuncPtr+0)
STR	R1, [R0, #0]
;UART1.c,226 :: 		break;
IT	AL
BAL	L_UART1_Rx116
;UART1.c,228 :: 		default:
L_UART1_Rx120:
;UART1.c,229 :: 		if (RcvBufPtr < (RcvBufSize-2))     // Prevents buffer overrun
MOVW	R0, #lo_addr(_RcvBufPtr+0)
MOVT	R0, #hi_addr(_RcvBufPtr+0)
LDRB	R0, [R0, #0]
CMP	R0, #254
IT	CS
BCS	L_UART1_Rx121
;UART1.c,230 :: 		RcvBuf[RcvBufPtr++] = rxchar;   // Put character in buffer
MOVW	R2, #lo_addr(_RcvBufPtr+0)
MOVT	R2, #hi_addr(_RcvBufPtr+0)
LDRB	R1, [R2, #0]
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
ADDS	R1, R0, R1
LDRB	R0, [SP, #4]
STRB	R0, [R1, #0]
MOV	R0, R2
LDRB	R0, [R0, #0]
ADDS	R0, R0, #1
STRB	R0, [R2, #0]
L_UART1_Rx121:
;UART1.c,231 :: 		break;
IT	AL
BAL	L_UART1_Rx116
;UART1.c,232 :: 		}
L_UART1_Rx115:
LDRB	R0, [SP, #4]
CMP	R0, #0
IT	EQ
BEQ	L_UART1_Rx117
LDRB	R0, [SP, #4]
CMP	R0, #13
IT	EQ
BEQ	L_UART1_Rx118
LDRB	R0, [SP, #4]
CMP	R0, #10
IT	EQ
BEQ	L_UART1_Rx119
IT	AL
BAL	L_UART1_Rx120
L_UART1_Rx116:
;UART1.c,233 :: 		}
L_UART1_Rx114:
;UART1.c,234 :: 		}
L_end_UART1_Rx1:
LDR	LR, [SP, #0]
ADD	SP, SP, #8
BX	LR
; end of _UART1_Rx1
_UART1_Rx2:
;UART1.c,240 :: 		void UART1_Rx2(void) {
SUB	SP, SP, #16
STR	LR, [SP, #0]
;UART1.c,245 :: 		switch (RcvBuf[0]) {  // Branch on command byte
IT	AL
BAL	L_UART1_Rx222
;UART1.c,248 :: 		case 'a':
L_UART1_Rx224:
;UART1.c,249 :: 		UART1_PutQueue("Command a received\r\n");
MOVW	R0, #lo_addr(?lstr1_UART1+0)
MOVT	R0, #hi_addr(?lstr1_UART1+0)
BL	_UART1_PutQueue+0
;UART1.c,250 :: 		break;
IT	AL
BAL	L_UART1_Rx223
;UART1.c,252 :: 		case 'b':
L_UART1_Rx225:
;UART1.c,253 :: 		SPI1_Initialize();
BL	_SPI1_Initialize+0
;UART1.c,254 :: 		Net_Wireless_CC3000_Init();
BL	_Net_Wireless_CC3000_Init+0
;UART1.c,255 :: 		Net_Wireless_CC3000_regAsynHandler(Net_Wireless_CC3000_UsynchCallback);
MOVW	R0, #lo_addr(_Net_Wireless_CC3000_UsynchCallback+0)
MOVT	R0, #hi_addr(_Net_Wireless_CC3000_UsynchCallback+0)
BL	_Net_Wireless_CC3000_RegAsynHandler+0
;UART1.c,256 :: 		NVIC_IntEnable(IVT_INT_GPIOB);
MOVW	R0, #17
BL	_NVIC_IntEnable+0
;UART1.c,257 :: 		Net_Wireless_CC3000_Start(0);
MOVS	R0, #0
BL	_Net_Wireless_CC3000_Start+0
;UART1.c,259 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
; BufNum start address is: 16 (R4)
MOV	R4, R0
;UART1.c,260 :: 		if (Net_Wireless_CC3000_NvmemReadSpVer(&Ver) == 0)
ADD	R0, SP, #12
STR	R4, [SP, #4]
BL	_Net_Wireless_CC3000_NvmemReadSpVer+0
LDR	R4, [SP, #4]
CMP	R0, #0
IT	NE
BNE	L_UART1_Rx226
;UART1.c,261 :: 		sprintf(BufNum,"Version: %d.%d\r\n",Ver[0],Ver[1]);
ADD	R1, SP, #12
ADDS	R0, R1, #1
LDRB	R0, [R0, #0]
UXTB	R3, R0
LDRB	R0, [R1, #0]
UXTB	R2, R0
MOVW	R1, #lo_addr(?lstr_2_UART1+0)
MOVT	R1, #hi_addr(?lstr_2_UART1+0)
MOV	R0, R4
STR	R4, [SP, #4]
PUSH	(R3)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #16
LDR	R4, [SP, #4]
IT	AL
BAL	L_UART1_Rx227
L_UART1_Rx226:
;UART1.c,263 :: 		strcpy(BufNum,"Error\r\n");
MOVW	R0, #lo_addr(?lstr3_UART1+0)
MOVT	R0, #hi_addr(?lstr3_UART1+0)
STR	R4, [SP, #4]
MOV	R1, R0
MOV	R0, R4
BL	_strcpy+0
LDR	R4, [SP, #4]
L_UART1_Rx227:
;UART1.c,265 :: 		UART1_PutQueue(BufNum);
MOV	R0, R4
; BufNum end address is: 16 (R4)
BL	_UART1_PutQueue+0
;UART1.c,266 :: 		Net_Wireless_CC3000_Stop();
BL	_Net_Wireless_CC3000_Stop+0
;UART1.c,267 :: 		break;
IT	AL
BAL	L_UART1_Rx223
;UART1.c,270 :: 		case 'c': // Set scan parameters for AP identification. Send this command first
L_UART1_Rx228:
;UART1.c,271 :: 		UART1_PutQueue("CC3000 initializing\r\n");
MOVW	R0, #lo_addr(?lstr4_UART1+0)
MOVT	R0, #hi_addr(?lstr4_UART1+0)
BL	_UART1_PutQueue+0
;UART1.c,272 :: 		SPI1_Initialize();
BL	_SPI1_Initialize+0
;UART1.c,273 :: 		Net_Wireless_CC3000_Init();
BL	_Net_Wireless_CC3000_Init+0
;UART1.c,274 :: 		Net_Wireless_CC3000_regAsynHandler(Net_Wireless_CC3000_UsynchCallback);
MOVW	R0, #lo_addr(_Net_Wireless_CC3000_UsynchCallback+0)
MOVT	R0, #hi_addr(_Net_Wireless_CC3000_UsynchCallback+0)
BL	_Net_Wireless_CC3000_RegAsynHandler+0
;UART1.c,275 :: 		NVIC_IntEnable(IVT_INT_GPIOB);
MOVW	R0, #17
BL	_NVIC_IntEnable+0
;UART1.c,276 :: 		Net_Wireless_CC3000_Start(0);
MOVS	R0, #0
BL	_Net_Wireless_CC3000_Start+0
;UART1.c,278 :: 		if (Net_Wireless_CC3000_SetScanParams(1, 100, 200, 5, 0x1fff, -75, 0, 205, 0) == 0)
MOVS	R4, #0
MOVS	R3, #205
MOVS	R2, #0
MVN	R1, #74
MOVW	R0, #8191
PUSH	(R4)
PUSH	(R3)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
MOVS	R3, #5
MOVS	R2, #200
MOVS	R1, #100
MOVS	R0, #1
BL	_Net_Wireless_CC3000_SetScanParams+0
ADD	SP, SP, #20
CMP	R0, #0
IT	NE
BNE	L_UART1_Rx229
;UART1.c,279 :: 		UART1_PutQueue("Success\r\n");
MOVW	R0, #lo_addr(?lstr5_UART1+0)
MOVT	R0, #hi_addr(?lstr5_UART1+0)
BL	_UART1_PutQueue+0
IT	AL
BAL	L_UART1_Rx230
L_UART1_Rx229:
;UART1.c,281 :: 		UART1_PutQueue("Failed\r\n");
MOVW	R0, #lo_addr(?lstr6_UART1+0)
MOVT	R0, #hi_addr(?lstr6_UART1+0)
BL	_UART1_PutQueue+0
L_UART1_Rx230:
;UART1.c,282 :: 		break;
IT	AL
BAL	L_UART1_Rx223
;UART1.c,284 :: 		case 'd': // Get scan result. Send this command multiple times to display all available APs. A blank line indicates end of AP list
L_UART1_Rx231:
;UART1.c,285 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
; BufNum start address is: 4 (R1)
MOV	R1, R0
;UART1.c,286 :: 		if (Net_Wireless_CC3000_GetScanResult(0, &myScanResult) == 0) {
STR	R1, [SP, #4]
MOVW	R1, #lo_addr(_myScanResult+0)
MOVT	R1, #hi_addr(_myScanResult+0)
MOVS	R0, #0
BL	_Net_Wireless_CC3000_GetScanResult+0
LDR	R1, [SP, #4]
CMP	R0, #0
IT	NE
BNE	L_UART1_Rx232
;UART1.c,287 :: 		strncpy(BufNum,myScanResult.ssidName,myScanResult.ssidNameLength);
MOVW	R0, #lo_addr(_myScanResult+6)
MOVT	R0, #hi_addr(_myScanResult+6)
LDRB	R0, [R0, #0]
STR	R1, [SP, #4]
SXTH	R2, R0
MOV	R0, R1
MOVW	R1, #lo_addr(_myScanResult+7)
MOVT	R1, #hi_addr(_myScanResult+7)
BL	_strncpy+0
LDR	R1, [SP, #4]
;UART1.c,288 :: 		strcat(BufNum,"\r\n");
MOVW	R0, #lo_addr(?lstr7_UART1+0)
MOVT	R0, #hi_addr(?lstr7_UART1+0)
STR	R1, [SP, #4]
STR	R1, [SP, #8]
MOV	R1, R0
LDR	R0, [SP, #8]
BL	_strcat+0
LDR	R1, [SP, #4]
;UART1.c,289 :: 		} else
IT	AL
BAL	L_UART1_Rx233
L_UART1_Rx232:
;UART1.c,290 :: 		strcpy(BufNum,"Error\r\n");
MOVW	R0, #lo_addr(?lstr8_UART1+0)
MOVT	R0, #hi_addr(?lstr8_UART1+0)
STR	R1, [SP, #4]
STR	R1, [SP, #8]
MOV	R1, R0
LDR	R0, [SP, #8]
BL	_strcpy+0
LDR	R1, [SP, #4]
L_UART1_Rx233:
;UART1.c,292 :: 		UART1_PutQueue(BufNum);
MOV	R0, R1
; BufNum end address is: 4 (R1)
BL	_UART1_PutQueue+0
;UART1.c,293 :: 		break;
IT	AL
BAL	L_UART1_Rx223
;UART1.c,295 :: 		case 'e': // Unused
L_UART1_Rx234:
;UART1.c,296 :: 		UART1_PutQueue("Unused command\r\n");
MOVW	R0, #lo_addr(?lstr9_UART1+0)
MOVT	R0, #hi_addr(?lstr9_UART1+0)
BL	_UART1_PutQueue+0
;UART1.c,297 :: 		break;
IT	AL
BAL	L_UART1_Rx223
;UART1.c,299 :: 		case 'f': // Unused
L_UART1_Rx235:
;UART1.c,300 :: 		UART1_PutQueue("Unused command\r\n");
MOVW	R0, #lo_addr(?lstr10_UART1+0)
MOVT	R0, #hi_addr(?lstr10_UART1+0)
BL	_UART1_PutQueue+0
;UART1.c,301 :: 		break;
IT	AL
BAL	L_UART1_Rx223
;UART1.c,303 :: 		case 'g': // Display initial IP address. Normally set to 0.0.0.0 and dhcp will assign it later
L_UART1_Rx236:
;UART1.c,304 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
; BufNum start address is: 24 (R6)
MOV	R6, R0
;UART1.c,305 :: 		sprintf(BufNum,"My IP: %d.%d.%d.%d\r\n",myIpAddr[0],myIpAddr[1],myIpAddr[2],myIpAddr[3]);
MOVW	R1, #lo_addr(_myIpAddr+12)
MOVT	R1, #hi_addr(_myIpAddr+12)
LDR	R5, [R1, #0]
MOVW	R1, #lo_addr(_myIpAddr+8)
MOVT	R1, #hi_addr(_myIpAddr+8)
LDR	R4, [R1, #0]
MOVW	R1, #lo_addr(_myIpAddr+4)
MOVT	R1, #hi_addr(_myIpAddr+4)
LDR	R3, [R1, #0]
MOVW	R1, #lo_addr(_myIpAddr+0)
MOVT	R1, #hi_addr(_myIpAddr+0)
LDR	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_11_UART1+0)
MOVT	R1, #hi_addr(?lstr_11_UART1+0)
STR	R6, [SP, #4]
PUSH	(R5)
PUSH	(R4)
PUSH	(R3)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #24
LDR	R6, [SP, #4]
;UART1.c,306 :: 		UART1_PutQueue(BufNum);
MOV	R0, R6
; BufNum end address is: 24 (R6)
BL	_UART1_PutQueue+0
;UART1.c,307 :: 		break;
IT	AL
BAL	L_UART1_Rx223
;UART1.c,309 :: 		case 'h': // Display DHCP assigned addresses
L_UART1_Rx237:
;UART1.c,310 :: 		DispDHCP();
BL	_DispDHCP+0
;UART1.c,311 :: 		break;
IT	AL
BAL	L_UART1_Rx223
;UART1.c,313 :: 		case 'i': // Unused
L_UART1_Rx238:
;UART1.c,314 :: 		UART1_PutQueue("Unused command\r\n");
MOVW	R0, #lo_addr(?lstr12_UART1+0)
MOVT	R0, #hi_addr(?lstr12_UART1+0)
BL	_UART1_PutQueue+0
;UART1.c,315 :: 		break;
IT	AL
BAL	L_UART1_Rx223
;UART1.c,317 :: 		case 'j': // Unused
L_UART1_Rx239:
;UART1.c,318 :: 		UART1_PutQueue("Unused command\r\n");
MOVW	R0, #lo_addr(?lstr13_UART1+0)
MOVT	R0, #hi_addr(?lstr13_UART1+0)
BL	_UART1_PutQueue+0
;UART1.c,319 :: 		break;
IT	AL
BAL	L_UART1_Rx223
;UART1.c,321 :: 		case 'k': // Display a register
L_UART1_Rx240:
;UART1.c,322 :: 		SPI1_Initialize();
BL	_SPI1_Initialize+0
;UART1.c,323 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
; BufNum start address is: 12 (R3)
MOV	R3, R0
;UART1.c,324 :: 		sprintf(BufNum,"Register: %08LX\r\n",SSI1_CR0);
MOVW	R1, #lo_addr(SSI1_CR0+0)
MOVT	R1, #hi_addr(SSI1_CR0+0)
LDR	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_14_UART1+0)
MOVT	R1, #hi_addr(?lstr_14_UART1+0)
STR	R3, [SP, #4]
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
LDR	R3, [SP, #4]
;UART1.c,325 :: 		UART1_PutQueue(BufNum);
MOV	R0, R3
; BufNum end address is: 12 (R3)
BL	_UART1_PutQueue+0
;UART1.c,326 :: 		break;
IT	AL
BAL	L_UART1_Rx223
;UART1.c,328 :: 		case 'l': // Show CC3000 State machine State if hung-up
L_UART1_Rx241:
;UART1.c,329 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
; BufNum start address is: 12 (R3)
MOV	R3, R0
;UART1.c,330 :: 		sprintf(BufNum,"Current State of CC3000 state machine: %d\r\n",State);
MOVW	R1, #lo_addr(_State+0)
MOVT	R1, #hi_addr(_State+0)
LDRB	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_15_UART1+0)
MOVT	R1, #hi_addr(?lstr_15_UART1+0)
STR	R3, [SP, #4]
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
LDR	R3, [SP, #4]
;UART1.c,331 :: 		UART1_PutQueue(BufNum);
MOV	R0, R3
; BufNum end address is: 12 (R3)
BL	_UART1_PutQueue+0
;UART1.c,332 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
; BufNum start address is: 12 (R3)
MOV	R3, R0
;UART1.c,333 :: 		sprintf(BufNum,"Current State of RTCC state machine: %d\r\n",RTC_State);
MOVW	R1, #lo_addr(_RTC_State+0)
MOVT	R1, #hi_addr(_RTC_State+0)
LDRB	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_16_UART1+0)
MOVT	R1, #hi_addr(?lstr_16_UART1+0)
STR	R3, [SP, #4]
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
LDR	R3, [SP, #4]
;UART1.c,334 :: 		UART1_PutQueue(BufNum);
MOV	R0, R3
; BufNum end address is: 12 (R3)
BL	_UART1_PutQueue+0
;UART1.c,335 :: 		break;
IT	AL
BAL	L_UART1_Rx223
;UART1.c,337 :: 		case 'm': // Run State machine to display all APs in the area
L_UART1_Rx242:
;UART1.c,338 :: 		State = 33;
MOVS	R1, #33
MOVW	R0, #lo_addr(_State+0)
MOVT	R0, #hi_addr(_State+0)
STRB	R1, [R0, #0]
;UART1.c,340 :: 		break;
IT	AL
BAL	L_UART1_Rx223
;UART1.c,342 :: 		case 'n': // Run State machine with diagnostic displays
L_UART1_Rx243:
;UART1.c,343 :: 		State = 38;
MOVS	R1, #38
MOVW	R0, #lo_addr(_State+0)
MOVT	R0, #hi_addr(_State+0)
STRB	R1, [R0, #0]
;UART1.c,344 :: 		break;
IT	AL
BAL	L_UART1_Rx223
;UART1.c,347 :: 		case 'o': // Run State machine to obtain date and time from server and store into RTC calendar registers
L_UART1_Rx244:
;UART1.c,348 :: 		RTC_State = 1;
MOVS	R1, #1
MOVW	R0, #lo_addr(_RTC_State+0)
MOVT	R0, #hi_addr(_RTC_State+0)
STRB	R1, [R0, #0]
;UART1.c,349 :: 		break;
IT	AL
BAL	L_UART1_Rx223
;UART1.c,351 :: 		case 'p': // Read calendar registers and display
L_UART1_Rx245:
;UART1.c,352 :: 		RTC_State = 16;
MOVS	R1, #16
MOVW	R0, #lo_addr(_RTC_State+0)
MOVT	R0, #hi_addr(_RTC_State+0)
STRB	R1, [R0, #0]
;UART1.c,353 :: 		break;
IT	AL
BAL	L_UART1_Rx223
;UART1.c,355 :: 		case 'r': // Display contror register
L_UART1_Rx246:
;UART1.c,356 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
; BufNum start address is: 12 (R3)
MOV	R3, R0
;UART1.c,357 :: 		sprintf(BufNum,"Register: %08LX\r\n",HIB_CTL);
MOVW	R1, #lo_addr(HIB_CTL+0)
MOVT	R1, #hi_addr(HIB_CTL+0)
LDR	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_17_UART1+0)
MOVT	R1, #hi_addr(?lstr_17_UART1+0)
STR	R3, [SP, #4]
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
LDR	R3, [SP, #4]
;UART1.c,358 :: 		UART1_PutQueue(BufNum);
MOV	R0, R3
; BufNum end address is: 12 (R3)
BL	_UART1_PutQueue+0
;UART1.c,359 :: 		break;
IT	AL
BAL	L_UART1_Rx223
;UART1.c,361 :: 		case 's': // Run State machine to contact time server only
L_UART1_Rx247:
;UART1.c,362 :: 		State = 1;
MOVS	R1, #1
MOVW	R0, #lo_addr(_State+0)
MOVT	R0, #hi_addr(_State+0)
STRB	R1, [R0, #0]
;UART1.c,363 :: 		break;
IT	AL
BAL	L_UART1_Rx223
;UART1.c,365 :: 		case 't': // Debug
L_UART1_Rx248:
;UART1.c,366 :: 		Value = Net_Wireless_CC3000_Time;
MOVW	R0, #lo_addr(_Net_Wireless_CC3000_Time+0)
MOVT	R0, #hi_addr(_Net_Wireless_CC3000_Time+0)
; Value start address is: 4 (R1)
LDR	R1, [R0, #0]
;UART1.c,367 :: 		BufNum = GetBuffer();
STR	R1, [SP, #4]
BL	_GetBuffer+0
LDR	R1, [SP, #4]
; BufNum start address is: 12 (R3)
MOV	R3, R0
;UART1.c,368 :: 		sprintf(BufNum,"Time: %d\r\n",Value);
MOV	R2, R1
; Value end address is: 4 (R1)
MOVW	R1, #lo_addr(?lstr_18_UART1+0)
MOVT	R1, #hi_addr(?lstr_18_UART1+0)
STR	R3, [SP, #4]
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
LDR	R3, [SP, #4]
;UART1.c,369 :: 		UART1_PutQueue(BufNum);
MOV	R0, R3
; BufNum end address is: 12 (R3)
BL	_UART1_PutQueue+0
;UART1.c,370 :: 		break;
IT	AL
BAL	L_UART1_Rx223
;UART1.c,372 :: 		case 'u': // Debug
L_UART1_Rx249:
;UART1.c,373 :: 		Value = RTCC_Read(&DateAndTime);
MOVW	R0, #lo_addr(_DateAndTime+0)
MOVT	R0, #hi_addr(_DateAndTime+0)
BL	_RTCC_Read+0
;UART1.c,374 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
; BufNum start address is: 32 (R8)
MOV	R8, R0
;UART1.c,376 :: 		DateAndTime.mn,DateAndTime.ss);
MOVW	R1, #lo_addr(_DateAndTime+0)
MOVT	R1, #hi_addr(_DateAndTime+0)
LDRB	R7, [R1, #0]
MOVW	R1, #lo_addr(_DateAndTime+1)
MOVT	R1, #hi_addr(_DateAndTime+1)
LDRB	R6, [R1, #0]
;UART1.c,375 :: 		sprintf(BufNum,"Date: %d/%d/%d  Time: %d:%d:%d\r\n",DateAndTime.yy,DateAndTime.mo,DateAndTime.md,DateAndTime.hh,
MOVW	R1, #lo_addr(_DateAndTime+2)
MOVT	R1, #hi_addr(_DateAndTime+2)
LDRB	R5, [R1, #0]
MOVW	R1, #lo_addr(_DateAndTime+3)
MOVT	R1, #hi_addr(_DateAndTime+3)
LDRB	R4, [R1, #0]
MOVW	R1, #lo_addr(_DateAndTime+5)
MOVT	R1, #hi_addr(_DateAndTime+5)
LDRB	R3, [R1, #0]
MOVW	R1, #lo_addr(_DateAndTime+6)
MOVT	R1, #hi_addr(_DateAndTime+6)
LDRH	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_19_UART1+0)
MOVT	R1, #hi_addr(?lstr_19_UART1+0)
;UART1.c,376 :: 		DateAndTime.mn,DateAndTime.ss);
STR	R8, [SP, #4]
PUSH	(R7)
PUSH	(R6)
;UART1.c,375 :: 		sprintf(BufNum,"Date: %d/%d/%d  Time: %d:%d:%d\r\n",DateAndTime.yy,DateAndTime.mo,DateAndTime.md,DateAndTime.hh,
PUSH	(R5)
PUSH	(R4)
PUSH	(R3)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
;UART1.c,376 :: 		DateAndTime.mn,DateAndTime.ss);
BL	_sprintf+0
ADD	SP, SP, #32
LDR	R8, [SP, #4]
;UART1.c,377 :: 		UART1_PutQueue(BufNum);
MOV	R0, R8
; BufNum end address is: 32 (R8)
BL	_UART1_PutQueue+0
;UART1.c,378 :: 		break;
IT	AL
BAL	L_UART1_Rx223
;UART1.c,380 :: 		case 'v': // Disable hybernate (RTC) circuits
L_UART1_Rx250:
;UART1.c,381 :: 		HibernateRTCDisable();
BL	_HibernateRTCDisable+0
;UART1.c,382 :: 		break;
IT	AL
BAL	L_UART1_Rx223
;UART1.c,384 :: 		case 'w': // Debug
L_UART1_Rx251:
;UART1.c,385 :: 		RTC_Init();
BL	_RTC_Init+0
;UART1.c,386 :: 		break;
IT	AL
BAL	L_UART1_Rx223
;UART1.c,388 :: 		case 'x': // Test: Write calendar registers with fixed data
L_UART1_Rx252:
;UART1.c,389 :: 		RTC_State = 18;
MOVS	R1, #18
MOVW	R0, #lo_addr(_RTC_State+0)
MOVT	R0, #hi_addr(_RTC_State+0)
STRB	R1, [R0, #0]
;UART1.c,390 :: 		break;
IT	AL
BAL	L_UART1_Rx223
;UART1.c,392 :: 		case 'z':  // Microprocessor software reset
L_UART1_Rx253:
;UART1.c,393 :: 		SystemReset();
BL	_SystemReset+0
;UART1.c,394 :: 		break;
IT	AL
BAL	L_UART1_Rx223
;UART1.c,396 :: 		default:
L_UART1_Rx254:
;UART1.c,397 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
; BufNum start address is: 12 (R3)
MOV	R3, R0
;UART1.c,398 :: 		sprintf(BufNum,"Unknown command: %c\r\n",RcvBuf[0]);
MOVW	R1, #lo_addr(_RcvBuf+0)
MOVT	R1, #hi_addr(_RcvBuf+0)
LDRB	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_20_UART1+0)
MOVT	R1, #hi_addr(?lstr_20_UART1+0)
STR	R3, [SP, #4]
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
LDR	R3, [SP, #4]
;UART1.c,399 :: 		UART1_PutQueue(BufNum);
MOV	R0, R3
; BufNum end address is: 12 (R3)
BL	_UART1_PutQueue+0
;UART1.c,400 :: 		break;
IT	AL
BAL	L_UART1_Rx223
;UART1.c,401 :: 		}
L_UART1_Rx222:
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #97
IT	EQ
BEQ	L_UART1_Rx224
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #98
IT	EQ
BEQ	L_UART1_Rx225
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #99
IT	EQ
BEQ	L_UART1_Rx228
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #100
IT	EQ
BEQ	L_UART1_Rx231
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #101
IT	EQ
BEQ	L_UART1_Rx234
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #102
IT	EQ
BEQ	L_UART1_Rx235
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #103
IT	EQ
BEQ	L_UART1_Rx236
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #104
IT	EQ
BEQ	L_UART1_Rx237
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #105
IT	EQ
BEQ	L_UART1_Rx238
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #106
IT	EQ
BEQ	L_UART1_Rx239
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #107
IT	EQ
BEQ	L_UART1_Rx240
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #108
IT	EQ
BEQ	L_UART1_Rx241
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #109
IT	EQ
BEQ	L_UART1_Rx242
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #110
IT	EQ
BEQ	L_UART1_Rx243
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #111
IT	EQ
BEQ	L_UART1_Rx244
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #112
IT	EQ
BEQ	L_UART1_Rx245
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #114
IT	EQ
BEQ	L_UART1_Rx246
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #115
IT	EQ
BEQ	L_UART1_Rx247
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #116
IT	EQ
BEQ	L_UART1_Rx248
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #117
IT	EQ
BEQ	L_UART1_Rx249
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #118
IT	EQ
BEQ	L_UART1_Rx250
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #119
IT	EQ
BEQ	L_UART1_Rx251
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #120
IT	EQ
BEQ	L_UART1_Rx252
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #122
IT	EQ
BEQ	L_UART1_Rx253
IT	AL
BAL	L_UART1_Rx254
L_UART1_Rx223:
;UART1.c,402 :: 		UART1_RxFuncPtr = UART1_Rx1;  // Go back to state 1
MOVW	R1, #lo_addr(_UART1_Rx1+0)
MOVT	R1, #hi_addr(_UART1_Rx1+0)
MOVW	R0, #lo_addr(_UART1_RxFuncPtr+0)
MOVT	R0, #hi_addr(_UART1_RxFuncPtr+0)
STR	R1, [R0, #0]
;UART1.c,403 :: 		}
L_end_UART1_Rx2:
LDR	LR, [SP, #0]
ADD	SP, SP, #16
BX	LR
; end of _UART1_Rx2
_UART1_TxQueueInit:
;UART1.c,411 :: 		void UART1_TxQueueInit(void) {
;UART1.c,412 :: 		TxIn = TxOut = 0;         // Set pointers to 0
MOVS	R1, #0
MOVW	R0, #lo_addr(_TxOut+0)
MOVT	R0, #hi_addr(_TxOut+0)
STRB	R1, [R0, #0]
MOVS	R1, #0
MOVW	R0, #lo_addr(_TxIn+0)
MOVT	R0, #hi_addr(_TxIn+0)
STRB	R1, [R0, #0]
;UART1.c,413 :: 		XmtBufPtr = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_XmtBufPtr+0)
MOVT	R0, #hi_addr(_XmtBufPtr+0)
STRB	R1, [R0, #0]
;UART1.c,414 :: 		}
L_end_UART1_TxQueueInit:
BX	LR
; end of _UART1_TxQueueInit
_UART1_PutQueue:
;UART1.c,420 :: 		void UART1_PutQueue(char *msg) {
; msg start address is: 0 (R0)
; msg end address is: 0 (R0)
; msg start address is: 0 (R0)
;UART1.c,421 :: 		TxQueue[TxIn++] = msg;    // Put the message pointer into FIFO
MOVW	R3, #lo_addr(_TxIn+0)
MOVT	R3, #hi_addr(_TxIn+0)
LDRB	R1, [R3, #0]
LSLS	R2, R1, #2
MOVW	R1, #lo_addr(_TxQueue+0)
MOVT	R1, #hi_addr(_TxQueue+0)
ADDS	R1, R1, R2
STR	R0, [R1, #0]
; msg end address is: 0 (R0)
MOV	R1, R3
LDRB	R1, [R1, #0]
ADDS	R1, R1, #1
UXTB	R1, R1
STRB	R1, [R3, #0]
;UART1.c,422 :: 		if (TxIn > (txqsize-1))   // Adjust FIFO in pointer
CMP	R1, #63
IT	LS
BLS	L_UART1_PutQueue55
;UART1.c,423 :: 		TxIn = 0;
MOVS	R2, #0
MOVW	R1, #lo_addr(_TxIn+0)
MOVT	R1, #hi_addr(_TxIn+0)
STRB	R2, [R1, #0]
L_UART1_PutQueue55:
;UART1.c,424 :: 		}
L_end_UART1_PutQueue:
BX	LR
; end of _UART1_PutQueue
_UART1_SendMsg:
;UART1.c,429 :: 		void UART1_SendMsg(char *s) {
; s start address is: 0 (R0)
SUB	SP, SP, #4
STR	LR, [SP, #0]
; s end address is: 0 (R0)
; s start address is: 0 (R0)
;UART1.c,430 :: 		XmtBuf = s;               // Pointer to the message for the interrupt handler
MOVW	R1, #lo_addr(_XmtBuf+0)
MOVT	R1, #hi_addr(_XmtBuf+0)
STR	R0, [R1, #0]
; s end address is: 0 (R0)
;UART1.c,431 :: 		XmtBufPtr = 0;            // Set character counter to start of text message
MOVS	R2, #0
MOVW	R1, #lo_addr(_XmtBufPtr+0)
MOVT	R1, #hi_addr(_XmtBufPtr+0)
STRB	R2, [R1, #0]
;UART1.c,432 :: 		UART1_StartTx();          // Turn on the transmitter
BL	_UART1_StartTx+0
;UART1.c,433 :: 		}
L_end_UART1_SendMsg:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _UART1_SendMsg
_UART1_Tx:
;UART1.c,438 :: 		void UART1_Tx(void) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;UART1.c,439 :: 		UART1_TxFuncPtr();    // Use the function pointer to go to a state
MOVW	R4, #lo_addr(_UART1_TxFuncPtr+0)
MOVT	R4, #hi_addr(_UART1_TxFuncPtr+0)
LDR	R4, [R4, #0]
BLX	R4
;UART1.c,440 :: 		}
L_end_UART1_Tx:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _UART1_Tx
_UART1_Tx1:
;UART1.c,446 :: 		void UART1_Tx1(void) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;UART1.c,447 :: 		if (UART1_CheckFree()) {                 // Don't try to start transmitter if already transmitting
BL	_UART1_CheckFree+0
CMP	R0, #0
IT	EQ
BEQ	L_UART1_Tx156
;UART1.c,448 :: 		if (TxIn != TxOut) {                 // If pointers are not the same there is something to send
MOVW	R0, #lo_addr(_TxOut+0)
MOVT	R0, #hi_addr(_TxOut+0)
LDRB	R1, [R0, #0]
MOVW	R0, #lo_addr(_TxIn+0)
MOVT	R0, #hi_addr(_TxIn+0)
LDRB	R0, [R0, #0]
CMP	R0, R1
IT	EQ
BEQ	L_UART1_Tx157
;UART1.c,449 :: 		UART1_SendMsg(TxQueue[TxOut++]); // Hand off the message address and increment queue out pointer
MOVW	R0, #lo_addr(_TxOut+0)
MOVT	R0, #hi_addr(_TxOut+0)
LDRB	R0, [R0, #0]
LSLS	R1, R0, #2
MOVW	R0, #lo_addr(_TxQueue+0)
MOVT	R0, #hi_addr(_TxQueue+0)
ADDS	R0, R0, R1
LDR	R0, [R0, #0]
BL	_UART1_SendMsg+0
MOVW	R1, #lo_addr(_TxOut+0)
MOVT	R1, #hi_addr(_TxOut+0)
LDRB	R0, [R1, #0]
ADDS	R0, R0, #1
UXTB	R0, R0
STRB	R0, [R1, #0]
;UART1.c,450 :: 		if (TxOut > (txqsize-1))         // Check for wrap
CMP	R0, #63
IT	LS
BLS	L_UART1_Tx158
;UART1.c,451 :: 		TxOut = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_TxOut+0)
MOVT	R0, #hi_addr(_TxOut+0)
STRB	R1, [R0, #0]
L_UART1_Tx158:
;UART1.c,452 :: 		}
L_UART1_Tx157:
;UART1.c,453 :: 		}
L_UART1_Tx156:
;UART1.c,454 :: 		}
L_end_UART1_Tx1:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _UART1_Tx1
_UART1_Send:
;UART1.c,459 :: 		void UART1_Send(char *s) {
SUB	SP, SP, #8
STR	LR, [SP, #0]
STR	R0, [SP, #4]
;UART1.c,460 :: 		EnableInterrupts();
BL	_EnableInterrupts+0
;UART1.c,461 :: 		while (UART1_CheckFree == 0) {}
L_UART1_Send59:
MOVW	R1, #lo_addr(_UART1_CheckFree+0)
MOVT	R1, #hi_addr(_UART1_CheckFree+0)
CMP	R1, #0
IT	NE
BNE	L_UART1_Send60
IT	AL
BAL	L_UART1_Send59
L_UART1_Send60:
;UART1.c,462 :: 		UART1_PutQueue(s);
LDR	R0, [SP, #4]
BL	_UART1_PutQueue+0
;UART1.c,463 :: 		UART1_Tx();
BL	_UART1_Tx+0
;UART1.c,464 :: 		while (UART1_CheckFree == 0) {}
L_UART1_Send61:
MOVW	R1, #lo_addr(_UART1_CheckFree+0)
MOVT	R1, #hi_addr(_UART1_CheckFree+0)
CMP	R1, #0
IT	NE
BNE	L_UART1_Send62
IT	AL
BAL	L_UART1_Send61
L_UART1_Send62:
;UART1.c,465 :: 		}
L_end_UART1_Send:
LDR	LR, [SP, #0]
ADD	SP, SP, #8
BX	LR
; end of _UART1_Send
