/**************************************************************************************************
  UART1.h
  Serial interface for the FT232RL chip on the shield for Tiva.
**************************************************************************************************/
#ifndef UART1_H
#define UART1_H


// Defines
#define DC3 0x13         // XOFF control character
#define DC1 0x11         // XON control character
#define NUL 0x00         // NUL control character


#define RcvBufSize 256   // Number of bytes in Receive Buffer
#define rxqsize 256      // Number of characters in receive buffer queue
#define txqsize 64       // Number of pointers in transmit queue



typedef void (* tPointerFcn)(void);  // Pointer to a function


// Function Prototypes
void UART1_Enable(void);
void UART1_StartRx(void);
void UART1_StartTx(void);
char UART1_CheckFree(void);

void UART1_Initialize(void);
void UART1_RxQueueInit(void);
char UART1_GetChar(char *rxbyte);
void UART1_Rx(void);
void UART1_Rx1(void);
void UART1_Rx2(void);

void UART1_TxQueueInit(void);
void UART1_PutQueue(char *msg);
void UART1_SendMsg(char *s);
void UART1_Tx(void);
void UART1_Tx1(void);
void UART1_Send(char *s);






#endif