
{This program uses Async Professional. Get it at http://tpapro.sourceforge.net/}

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, Menus, ComCtrls, StdCtrls, AdSelCom, OoMisc, AdPort,
  AdStatLt;

type
  TForm1 = class(TForm)
    StatusBar1: TStatusBar;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Clear1: TMenuItem;
    Exit1: TMenuItem;
    Panel1: TPanel;
    Panel2: TPanel;
    ApdComPort1: TApdComPort;
    ApdSLController1: TApdSLController;
    Memo1: TMemo;
    Board1: TMenuItem;
    ShowDateTime1: TMenuItem;
    SetDateTime1: TMenuItem;
    GroupBox1: TGroupBox;
    ApdStatusLight1: TApdStatusLight;
    ApdStatusLight2: TApdStatusLight;
    ApdStatusLight3: TApdStatusLight;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    GroupBox2: TGroupBox;
    ApdStatusLight4: TApdStatusLight;
    ApdStatusLight5: TApdStatusLight;
    ApdStatusLight6: TApdStatusLight;
    ApdStatusLight7: TApdStatusLight;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    GroupBox3: TGroupBox;
    Edit1: TEdit;
    Button1: TButton;
    GroupBox4: TGroupBox;
    ComboBox2: TComboBox;
    GroupBox5: TGroupBox;
    ComboBox1: TComboBox;
    SDCard1: TMenuItem;
    GetDir1: TMenuItem;
    GetFile1: TMenuItem;
    N1: TMenuItem;
    DeleteFile1: TMenuItem;
    N2: TMenuItem;
    SetRTCC1: TMenuItem;
    SetSite1: TMenuItem;
    SetSelection: TMenuItem;
    SaveAs1: TMenuItem;
    SaveDialog1: TSaveDialog;
    GPS1: TMenuItem;
    QueryZDA1: TMenuItem;
    SetOutput1: TMenuItem;
    QueryOutput1: TMenuItem;
    QueryGLL1: TMenuItem;
    QueryRMC1: TMenuItem;
    QueryVTG1: TMenuItem;
    QueryGGA1: TMenuItem;
    QueryGSA1: TMenuItem;
    QueryGSV1: TMenuItem;
    Verbose1: TMenuItem;
    N3: TMenuItem;
    SetExternalRTC1: TMenuItem;
    ReadExternalRTC1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure ComboBox2Change(Sender: TObject);
    procedure ApdComPort1TriggerAvail(CP: TObject; Count: Word);
    procedure ApdComPort1TriggerData(CP: TObject; TriggerHandle: Word);
    procedure ShowDateTime1Click(Sender: TObject);
    procedure SetDateTime1Click(Sender: TObject);
    procedure Clear1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Memo1DblClick(Sender: TObject);
    procedure GetDir1Click(Sender: TObject);
    procedure GetFile1Click(Sender: TObject);
    procedure DeleteFile1Click(Sender: TObject);
    procedure SetRTCC1Click(Sender: TObject);
    procedure SetSite1Click(Sender: TObject);
    procedure SetSelectionClick(Sender: TObject);
    procedure SaveAs1Click(Sender: TObject);
    procedure QueryZDA1Click(Sender: TObject);
    procedure SetOutput1Click(Sender: TObject);
    procedure QueryOutput1Click(Sender: TObject);
    procedure QueryGLL1Click(Sender: TObject);
    procedure QueryRMC1Click(Sender: TObject);
    procedure QueryVTG1Click(Sender: TObject);
    procedure QueryGGA1Click(Sender: TObject);
    procedure QueryGSA1Click(Sender: TObject);
    procedure QueryGSV1Click(Sender: TObject);
    procedure Verbose1Click(Sender: TObject);
    procedure SetExternalRTC1Click(Sender: TObject);
    procedure ReadExternalRTC1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    RcvBuf: AnsiString;
    TempString: AnsiString;
    WorkString: AnsiString;
    LFTrigger: word;
    //Verbose: bool;

    function GetFirstToken(S: string; Token: Char): string;
    function StripFirstToken(S: string; Token: Char): string;
    function Int2StrPad0(N: LongInt; Len: Integer): string;
    function CleanString(S: string): string;
    procedure SendToGPS(S: string);
    procedure DecodeResponse;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

const
  BaudTable: array[0..9] of integer = (300,600,1200,2400,4800,9600,19200,
  38400,57600,115200);

  NUL = #0;   //null
  SOH = #1;   //start of heading
  STX = #2;   //start of text
  ETX = #3;   //end of text
  EOT = #4;   //end of transmission
  ENQ = #5;   //enquiry
  ACK = #6;   //acknowledge
  BEL = #7;   //bell
  BS  = #8;   //backspace
  HT  = #9;   //horizontal tab
  LF  = #10;  //line feed
  VT  = #11;  //vertical tab
  FF  = #12;  //form feed
  CR  = #13;  //carriage return
  SO  = #14;  //shift out
  SI  = #15;  //shift in
  DLE = #16;  //data link escape
  DC1 = #17;  //device control 1
  DC2 = #18;  //device control 2
  DC3 = #19;  //device control 3
  DC4 = #20;  //device control 4
  NAK = #21;  //negative acknowledge
  SYN = #22;  //synchronous idle
  ETB = #23;  //end of trans. block
  CAN = #24;  //cancel
  EM  = #25;  //end of medium
  SUB = #26;  //substitute
  ESC = #27;  //escape
  FS  = #28;  //file separator
  GS  = #29;  //group separator
  RS  = #30;  //record separator
  US  = #31;  //unit separator
  DEL = #127; //delete

  CRLF = #13+#10;



function TForm1.GetFirstToken(S: string; Token: Char): string;
var
  Count: Integer;
  Temp: string;
begin
  Count := Pos(Token, S);
  if Count < 1 then
  begin
    GetFirstToken := '';
    Exit;
  end;
  Dec(Count);
  Temp := Copy(S,1,Count);
  GetFirstToken := Temp;
end;

function TForm1.StripFirstToken(S: string; Token: Char): string;
var
  Count: integer;
  Temp: string;
begin
  Count := Pos(Token, S);
  if Count = 0 then begin
    StripFirstToken := S;
    Exit;
  end;
  Temp := S;
  Delete(Temp,1,Count);
  StripFirstToken := Temp;
end;

function TForm1.Int2StrPad0(N: LongInt; Len: Integer): string;
var
  S : string;
begin
  Str(N:0,S);
  while Length(S) < Len do
    S := '0' + S;
  Int2StrPad0 := S;
end;

function TForm1.CleanString(S: string): string;
var
  Temp: string;
  i: integer;
  Ch: char;

begin

  for i := 1 to Length(S) do
  begin
    Ch := S[i];
    if Ch > chr(31) then
    begin
      Temp := Temp + Ch;
    end;
  end;
  CleanString := Temp;
end;

procedure TForm1.SendToGPS(S: string);
var
  Checksum: byte;
  i: integer;
begin
  Checksum := 0;
  for i := 2 to Length(S)-1 do
  begin
    Checksum := Checksum xor byte(S[i]);

  ApdComPort1.PutString(S + IntToHex(Checksum,2) + CRLF);
  StatusBar1.Panels[1].Text := S + IntToHex(Checksum,2) + CRLF;
  //StatusBar1.Panels[0].Text := IntToStr(Length(S));
  end;
end;

procedure TForm1.DecodeResponse;
var
  //Ch: Byte;

  Time, Date, Latitude, Longitude, Misc, Speed, COG: string;
  NorthSouth, EastWest, DataValid, PosMode: string;
  COGM, Mode, SpeedKnots, SpeedKmPerHr, MagVar: string;
  FixStatus, NumSat, PDOP, HDOP, VDOP, Altitude, GeoID, DGPS1, DGPS2: string;
  Sat1, Sat2, Sat3, Sat4, Sat5, Sat6, Sat7, Sat8, Sat9, Sat10, Sat11, Sat12: string;
  Day, Month, Year, LocZoneHrs, LocZoneMin: string;

  NumMsg, MsgSeq, SatInView: Integer;
  SatID, Elev, Azim, SNR: Integer;


begin

  if ((TempString[2] = 'G') and (TempString[3] = 'P')) then
  begin

//------------------------------------------------------------------------------
    if ((TempString[4] = 'G') AND (TempString[5] = 'L') AND (TempString[6] = 'L')) then // GLL
    begin
      WorkString := TempString;
      Misc := GetFirstToken(WorkString,',');
      WorkString := StripFirstToken(WorkString,','); // Remove '$GPGLL,'

      //WorkString := GetFirstToken(WorkString,'*');   // Remove the * at the end of data

      Latitude := GetFirstToken(WorkString,',');
      WorkString := StripFirstToken(WorkString,','); // Remove latitude

      NorthSouth := GetFirstToken(WorkString,',');
      WorkString := StripFirstToken(WorkString,','); // Remove N/S

      Longitude := GetFirstToken(WorkString,',');
      WorkString := StripFirstToken(WorkString,','); // Remove longitude

      EastWest := GetFirstToken(WorkString,',');
      WorkString := StripFirstToken(WorkString,','); // Remove E/W

      Time := GetFirstToken(WorkString,',');
      WorkString := StripFirstToken(WorkString,','); // Remove time

      DataValid := GetFirstToken(WorkString,',');
      WorkString := StripFirstToken(WorkString,','); // Remove data valid

      PosMode := GetFirstToken(WorkString,'*');
      WorkString := StripFirstToken(WorkString,'*'); // Remove positioning mode

      Memo1.Lines.Add('Latitude: '+Latitude+' '+NorthSouth);
      Memo1.Lines.Add('Longitude: '+Longitude+' '+EastWest);
      Memo1.Lines.Add('Time: '+Time);
      if (DataValid = 'V') then Memo1.Lines.Add('Data: invalid')
      else if (DataValid = 'A') then Memo1.Lines.Add('Data: valid');
      if (PosMode = 'N') then Memo1.Lines.Add('Poitioning mode: no fix')
      else if (PosMode = 'A') then Memo1.Lines.Add('Positioning mode: autonomous GNSS fix')
      else if (PosMode = 'D') then Memo1.Lines.Add('Positioning mode: differential GNSS fix');
    end;

//------------------------------------------------------------------------------
    if ((TempString[4] = 'R') AND (TempString[5] = 'M') AND (TempString[6] = 'C')) then // RMC
    begin
      WorkString := TempString;
      Misc := GetFirstToken(WorkString,',');
      WorkString := StripFirstToken(WorkString,','); // Remove '$GPRMC,'

      Time := GetFirstToken(WorkString,',');
      WorkString := StripFirstToken(WorkString,','); // Remove time

      DataValid := GetFirstToken(WorkString,',');
      WorkString := StripFirstToken(WorkString,','); // Remove data valid

      Latitude := GetFirstToken(WorkString,',');
      WorkString := StripFirstToken(WorkString,','); // Remove latitude

      NorthSouth := GetFirstToken(WorkString,',');
      WorkString := StripFirstToken(WorkString,','); // Remove N/S

      Longitude := GetFirstToken(WorkString,',');
      WorkString := StripFirstToken(WorkString,','); // Remove longitude

      EastWest := GetFirstToken(WorkString,',');
      WorkString := StripFirstToken(WorkString,','); // Remove E/W

      Speed := GetFirstToken(WorkString,',');
      WorkString := StripFirstToken(WorkString,','); // Remove speed

      COG := GetFirstToken(WorkString,',');
      WorkString := StripFirstToken(WorkString,','); // Remove course over ground

      Date := GetFirstToken(WorkString,',');
      WorkString := StripFirstToken(WorkString,','); // Remove date

      MagVar := GetFirstToken(WorkString,',');
      WorkString := StripFirstToken(WorkString,','); // Remove magnetic variation

      EastWest := GetFirstToken(WorkString,',');
      WorkString := StripFirstToken(WorkString,','); // Remove east/west indicator

      PosMode := GetFirstToken(WorkString,'*');
      WorkString := StripFirstToken(WorkString,'*'); // Remove positioning mode

      Memo1.Lines.Add('Time: '+Time);
      if (DataValid = 'V') then Memo1.Lines.Add('Data: invalid')
      else if (DataValid = 'A') then Memo1.Lines.Add('Data: valid');
      Memo1.Lines.Add('Latitude: '+Latitude+' '+NorthSouth);
      Memo1.Lines.Add('Longitude: '+Longitude+' '+EastWest);
      Memo1.Lines.Add('Speed over ground: '+Speed+' knots');
      Memo1.Lines.Add('Course over ground: '+COG+' degrees');
      Memo1.Lines.Add('Date: '+Date);
      if (PosMode = 'N') then Memo1.Lines.Add('Positioning mode: no fix')
      else if (PosMode = 'A') then Memo1.Lines.Add('Positioning mode: autonomous GNSS fix')
      else if (PosMode = 'D') then Memo1.Lines.Add('Positioning mode: differential GNSS fix');
    end;

//------------------------------------------------------------------------------
    if ((TempString[4] = 'V') AND (TempString[5] = 'T') AND (TempString[6] = 'G')) then // VTG
    begin
      WorkString := TempString;
      Misc := GetFirstToken(WorkString,',');
      WorkString := StripFirstToken(WorkString,','); // Remove '$GPVTG,'

      COG := GetFirstToken(WorkString,',');
      WorkString := StripFirstToken(WorkString,','); // Remove course over ground in degrees

      WorkString := StripFirstToken(WorkString,','); // Remove fixed field 'T'

      COGM := GetFirstToken(WorkString,',');
      WorkString := StripFirstToken(WorkString,','); // Remove course over ground magnetic

      WorkString := StripFirstToken(WorkString,','); // Remove fixed field 'M'

      SpeedKnots := GetFirstToken(WorkString,',');
      WorkString := StripFirstToken(WorkString,','); // Remove speed over ground in knots

      WorkString := StripFirstToken(WorkString,','); // Remove fixed field 'N'

      SpeedKmPerHr := GetFirstToken(WorkString,',');
      WorkString := StripFirstToken(WorkString,','); // Remove speed over ground in km/h

      WorkString := StripFirstToken(WorkString,','); // Remove fixed field 'K'

      PosMode := GetFirstToken(WorkString,'*');
      WorkString := StripFirstToken(WorkString,'*'); // Remove positioning mode

      Memo1.Lines.Add('Course over ground true: '+COG+' degrees');
      Memo1.Lines.Add('Course over ground magnetic: '+COGM+' magnetic');
      Memo1.Lines.Add('Speed over ground: '+SpeedKnots+' knots');
      Memo1.Lines.Add('Speed over ground: '+SpeedKmPerHr+' km/h');
      if (PosMode = 'N') then Memo1.Lines.Add('Positioning mode: no fix')
      else if (PosMode = 'A') then Memo1.Lines.Add('Positioning mode: autonomous GNSS fix')
      else if (PosMode = 'D') then Memo1.Lines.Add('Positioning mode: differential GNSS fix');
    end;

//------------------------------------------------------------------------------
    if ((TempString[4] = 'G') AND (TempString[5] = 'G') AND (TempString[6] = 'A')) then // GGA
    begin
      WorkString := TempString;
      Misc := GetFirstToken(WorkString,',');
      WorkString := StripFirstToken(WorkString,','); // Remove '$GPGGA,'

      Time := GetFirstToken(WorkString,',');
      WorkString := StripFirstToken(WorkString,','); // Remove time

      Latitude := GetFirstToken(WorkString,',');
      WorkString := StripFirstToken(WorkString,','); // Remove latitude

      NorthSouth := GetFirstToken(WorkString,',');
      WorkString := StripFirstToken(WorkString,','); // Remove N/S

      Longitude := GetFirstToken(WorkString,',');
      WorkString := StripFirstToken(WorkString,','); // Remove longitude

      EastWest := GetFirstToken(WorkString,',');
      WorkString := StripFirstToken(WorkString,','); // Remove E/W

      FixStatus := GetFirstToken(WorkString,',');
      WorkString := StripFirstToken(WorkString,','); // Remove fix status

      NumSat := GetFirstToken(WorkString,',');
      WorkString := StripFirstToken(WorkString,','); // Remove number of satelites

      HDOP := GetFirstToken(WorkString,',');
      WorkString := StripFirstToken(WorkString,','); // Remove horizontal dilution of precision

      Altitude := GetFirstToken(WorkString,',');
      WorkString := StripFirstToken(WorkString,','); // Remove altitude

      WorkString := StripFirstToken(WorkString,','); // Remove fixed field 'M'

      GeoID := GetFirstToken(WorkString,',');
      WorkString := StripFirstToken(WorkString,','); // Remove GeoID separation

      WorkString := StripFirstToken(WorkString,','); // Remove fixed field 'M'

      DGPS1 := GetFirstToken(WorkString,',');
      WorkString := StripFirstToken(WorkString,','); // Remove DGPS age

      DGPS2 := GetFirstToken(WorkString,'*');
      WorkString := StripFirstToken(WorkString,'*'); // Remove DGPS station ID

      Memo1.Lines.Add('Time: '+Time);
      Memo1.Lines.Add('Latitude: '+Latitude+' '+NorthSouth);
      Memo1.Lines.Add('Longitude: '+Longitude+' '+EastWest);
      if (FixStatus = '0') then Memo1.Lines.Add('Fix status: invalid')
      else if (FixStatus = '1') then Memo1.Lines.Add('Fix status: GPS fix')
      else if (FixStatus = '2') then Memo1.Lines.Add('Fix status: DGPS fix')
      else if (FixStatus = '3') then Memo1.Lines.Add('Fix status: PPS fix')
      else if (FixStatus = '4') then Memo1.Lines.Add('Fix status: real time kinematic')
      else if (FixStatus = '5') then Memo1.Lines.Add('Fix status: float RTK');
      Memo1.Lines.Add('Number of satelites: '+NumSat);
      Memo1.Lines.Add('Horizontal dilution precision: '+HDOP);
      Memo1.Lines.Add('Altitude: '+Altitude+' m');
      Memo1.Lines.Add('Height of GeoID above WGS84 ellipsoid: '+GeoID+' m');
    end;

//------------------------------------------------------------------------------
    if ((TempString[4] = 'G') AND (TempString[5] = 'S') AND (TempString[6] = 'A')) then // GSA
    begin
      WorkString := TempString;
      Misc := GetFirstToken(WorkString,',');
      WorkString := StripFirstToken(WorkString,','); // Remove '$GPGSA,'

      Mode := GetFirstToken(WorkString,',');
      WorkString := StripFirstToken(WorkString,','); // Remove mode

      FixStatus := GetFirstToken(WorkString,',');
      WorkString := StripFirstToken(WorkString,','); // Remove fix status

      Sat1 := GetFirstToken(WorkString,',');
      WorkString := StripFirstToken(WorkString,','); // Remove satelite 1

      Sat2 := GetFirstToken(WorkString,',');
      WorkString := StripFirstToken(WorkString,','); // Remove satelite 2

      Sat3 := GetFirstToken(WorkString,',');
      WorkString := StripFirstToken(WorkString,','); // Remove satelite 3

      Sat4 := GetFirstToken(WorkString,',');
      WorkString := StripFirstToken(WorkString,','); // Remove satelite 4

      Sat5 := GetFirstToken(WorkString,',');
      WorkString := StripFirstToken(WorkString,','); // Remove satelite 5

      Sat6 := GetFirstToken(WorkString,',');
      WorkString := StripFirstToken(WorkString,','); // Remove satelite 6

      Sat7 := GetFirstToken(WorkString,',');
      WorkString := StripFirstToken(WorkString,','); // Remove satelite 7

      Sat8 := GetFirstToken(WorkString,',');
      WorkString := StripFirstToken(WorkString,','); // Remove satelite 8

      Sat9 := GetFirstToken(WorkString,',');
      WorkString := StripFirstToken(WorkString,','); // Remove satelite 9

      Sat10 := GetFirstToken(WorkString,',');
      WorkString := StripFirstToken(WorkString,','); // Remove satelite 10

      Sat11 := GetFirstToken(WorkString,',');
      WorkString := StripFirstToken(WorkString,','); // Remove satelite 11

      Sat12 := GetFirstToken(WorkString,',');
      WorkString := StripFirstToken(WorkString,','); // Remove satelite 12

      PDOP := GetFirstToken(WorkString,',');
      WorkString := StripFirstToken(WorkString,','); // Remove position dilution of precision

      HDOP := GetFirstToken(WorkString,',');
      WorkString := StripFirstToken(WorkString,','); // Remove horizontal dilution of precision

      VDOP := GetFirstToken(WorkString,'*');
      WorkString := StripFirstToken(WorkString,'*'); // Remove vertical dilution of precision

      if (Mode = 'M') then Memo1.Lines.Add('Mode: manual (2D or 3D)')
      else if (Mode = 'A') then Memo1.Lines.Add('Mode: automatic (2D/3D)');

      if (FixStatus = '1') then Memo1.Lines.Add('Fix status: no fix')
      else if (FixStatus = '2') then Memo1.Lines.Add('Fix status: 2D fix')
      else if (FixStatus = '3') then Memo1.Lines.Add('Fix status: 3D fix');

      if (Sat1 <> '') then Memo1.Lines.Add('Satelite used on channel 1: '+Sat1);
      if (Sat2 <> '') then Memo1.Lines.Add('Satelite used on channel 2: '+Sat2);
      if (Sat3 <> '') then Memo1.Lines.Add('Satelite used on channel 3: '+Sat3);
      if (Sat4 <> '') then Memo1.Lines.Add('Satelite used on channel 4: '+Sat4);

      if (Sat5 <> '') then Memo1.Lines.Add('Satelite used on channel 5: '+Sat5);
      if (Sat6 <> '') then Memo1.Lines.Add('Satelite used on channel 6: '+Sat6);
      if (Sat7 <> '') then Memo1.Lines.Add('Satelite used on channel 7: '+Sat7);
      if (Sat8 <> '') then Memo1.Lines.Add('Satelite used on channel 8: '+Sat8);

      if (Sat9 <> '') then Memo1.Lines.Add('Satelite used on channel 9: '+Sat9);
      if (Sat10 <> '') then Memo1.Lines.Add('Satelite used on channel 10: '+Sat10);
      if (Sat11 <> '') then Memo1.Lines.Add('Satelite used on channel 11: '+Sat11);
      if (Sat12 <> '') then Memo1.Lines.Add('Satelite used on channel 12: '+Sat12);

      Memo1.Lines.Add('Position dilution of precision: '+PDOP);
      Memo1.Lines.Add('Horizontal dilution of precision: '+HDOP);
      Memo1.Lines.Add('Vertical dilution of precision: '+VDOP);
    end;

//------------------------------------------------------------------------------
    if ((TempString[4] = 'G') AND (TempString[5] = 'S') AND (TempString[6] = 'V')) then // GSV
    begin
      WorkString := TempString;
      Misc := GetFirstToken(WorkString,',');
      WorkString := StripFirstToken(WorkString,','); // Remove '$GPGSV,'

      WorkString := GetFirstToken(WorkString,'*');   // Remove the * at the end of data
      WorkString := WorkString+',';                  // Add a comma at the end of string

      Misc := GetFirstToken(WorkString,',');
      if (Misc <> '') then NumMsg := StrToInt(Misc) else NumMsg := 0;
      WorkString := StripFirstToken(WorkString,','); // Remove number of messages

      Misc := GetFirstToken(WorkString,',');
      if (Misc <> '') then MsgSeq := StrToInt(Misc) else MsgSeq := 0;
      WorkString := StripFirstToken(WorkString,','); // Remove sequence number

      Misc := GetFirstToken(WorkString,',');
      if (Misc <> '') then SatInView := StrToInt(Misc) else SatInView := 0;
      WorkString := StripFirstToken(WorkString,','); // Remove satelites in view number

      Memo1.Lines.Add('Num messages: '+IntToStr(NumMsg)+', Message sequence: '+IntToStr(MsgSeq)+', Satelites in view: '+IntToStr(SatInView));

      if (Length(TempString) > 0) then
      begin
        Misc := GetFirstToken(WorkString,',');
        if (Misc <> '') then SatID := StrToInt(Misc) else SatID := 0;
        WorkString := StripFirstToken(WorkString,','); // Remove satelite ID 1

        Misc := GetFirstToken(WorkString,',');
        if (Misc <> '') then Elev := StrToInt(Misc) else Elev := 0;
        WorkString := StripFirstToken(WorkString,','); // Remove elevation 1

        Misc := GetFirstToken(WorkString,',');
        if (Misc <> '') then Azim := StrToInt(Misc) else Azim := 0;
        WorkString := StripFirstToken(WorkString,','); // Remove azimuth 1

        Misc := GetFirstToken(WorkString,',');
        if (Misc <> '') then SNR := StrToInt(Misc) else SNR := 0;
        WorkString := StripFirstToken(WorkString,','); // Remove signal to noise ratio 1

        Memo1.Lines.Add('Satelite ID: '+IntToStr(SatID)+', Elevation: '+IntToStr(Elev)+', Azimuth: '+IntToStr(Azim)+', SNR '+IntToStr(SNR));
      end;

      if (Length(TempString) > 0) then
      begin
        Misc := GetFirstToken(WorkString,',');
        if (Misc <> '') then SatID := StrToInt(Misc) else SatID := 0;
        WorkString := StripFirstToken(WorkString,','); // Remove satelite ID 2

        Misc := GetFirstToken(WorkString,',');
        if (Misc <> '') then Elev := StrToInt(Misc) else Elev := 0;
        WorkString := StripFirstToken(WorkString,','); // Remove elevation 2

        Misc := GetFirstToken(WorkString,',');
        if (Misc <> '') then Azim := StrToInt(Misc) else Azim := 0;
        WorkString := StripFirstToken(WorkString,','); // Remove azimuth 2

        Misc := GetFirstToken(WorkString,',');
        if (Misc <> '') then SNR := StrToInt(Misc) else SNR := 0;
        WorkString := StripFirstToken(WorkString,','); // Remove signal to noise ratio 2

        Memo1.Lines.Add('Satelite ID: '+IntToStr(SatID)+', Elevation: '+IntToStr(Elev)+', Azimuth: '+IntToStr(Azim)+', SNR '+IntToStr(SNR));
      end;

      if (Length(TempString) > 0) then
      begin
        Misc := GetFirstToken(WorkString,',');
        if (Misc <> '') then SatID := StrToInt(Misc) else SatID := 0;
        WorkString := StripFirstToken(WorkString,','); // Remove satelite ID 3

        Misc := GetFirstToken(WorkString,',');
        if (Misc <> '') then Elev := StrToInt(Misc) else Elev := 0;
        WorkString := StripFirstToken(WorkString,','); // Remove elevation 3

        Misc := GetFirstToken(WorkString,',');
        if (Misc <> '') then Azim := StrToInt(Misc) else Azim := 0;
        WorkString := StripFirstToken(WorkString,','); // Remove azimuth 3

        Misc := GetFirstToken(WorkString,',');
        if (Misc <> '') then SNR := StrToInt(Misc) else SNR := 0;
        WorkString := StripFirstToken(WorkString,','); // Remove signal to noise ratio 3

        Memo1.Lines.Add('Satelite ID: '+IntToStr(SatID)+', Elevation: '+IntToStr(Elev)+', Azimuth: '+IntToStr(Azim)+', SNR '+IntToStr(SNR));
      end;

      if (Length(TempString) > 0) then
      begin
        Misc := GetFirstToken(WorkString,',');
        if (Misc <> '') then SatID := StrToInt(Misc) else SatID := 0;
        WorkString := StripFirstToken(WorkString,','); // Remove satelite ID 4

        Misc := GetFirstToken(WorkString,',');
        if (Misc <> '') then Elev := StrToInt(Misc) else Elev := 0;
        WorkString := StripFirstToken(WorkString,','); // Remove elevation 4

        Misc := GetFirstToken(WorkString,',');
        if (Misc <> '') then Azim := StrToInt(Misc) else Azim := 0;
        WorkString := StripFirstToken(WorkString,','); // Remove azimuth 4

        Misc := GetFirstToken(WorkString,',');
        if (Misc <> '') then SNR := StrToInt(Misc) else SNR := 0;
        WorkString := StripFirstToken(WorkString,','); // Remove signal to noise ratio 4

        Memo1.Lines.Add('Satelite ID: '+IntToStr(SatID)+', Elevation: '+IntToStr(Elev)+', Azimuth: '+IntToStr(Azim)+', SNR '+IntToStr(SNR));
      end;
    end; // if (GSV)

//------------------------------------------------------------------------------
    if ((TempString[4] = 'Z') AND (TempString[5] = 'D') AND (TempString[6] = 'A')) then // ZDA
    begin
      WorkString := TempString;
      Misc := GetFirstToken(WorkString,',');
      WorkString := StripFirstToken(WorkString,','); // Remove '$GPZDA,'

      Time := GetFirstToken(WorkString,',');
      WorkString := StripFirstToken(WorkString,','); // Remove time

      Day := GetFirstToken(WorkString,',');
      WorkString := StripFirstToken(WorkString,','); // Remove day

      Month := GetFirstToken(WorkString,',');
      WorkString := StripFirstToken(WorkString,','); // Remove month

      Year := GetFirstToken(WorkString,',');
      WorkString := StripFirstToken(WorkString,','); // Remove year

      LocZoneHrs := GetFirstToken(WorkString,',');
      WorkString := StripFirstToken(WorkString,','); // Remove local zone hours

      LocZoneMin := GetFirstToken(WorkString,'*');
      WorkString := StripFirstToken(WorkString,'*'); // Remove local zone minutes

      Memo1.Lines.Add('Time: '+Copy(Time,1,2)+':'+Copy(Time,3,2)+':'+Copy(Time,5,6));
      Memo1.Lines.Add('Date: '+Year+'/'+Month+'/'+Day);
    end;

  end;
end;








//******************************************************************************
procedure TForm1.FormCreate(Sender: TObject);
var
  I: integer;
  TextInBox: string;
  NumInBox: string;
  TheComNum: integer;

begin
  Form1.Caption := 'Serial Utility';
  Panel1.Caption := '';
  Panel2.Caption := '';
  Memo1.Lines.Clear;
  Edit1.Text := '';


  {Uses AdSelCom}
  for I := 1 to 8 do
    if IsPortAvailable(I) then
      ComboBox1.Items.Add(ComName(I));
  if ComboBox1.Items.Count > 0 then
  begin
    ComboBox1.ItemIndex := 0;

    TextInBox := ComboBox1.Items[ComboBox1.ItemIndex];
    NumInBox :=  Copy(TextInBox,4,2);
    TheComNum := StrToInt(NumInBox);
    ApdComPort1.ComNumber := TheComNum;
    ApdSLController1.Monitoring := true;
    ApdComPort1.Open := true;
    LFTrigger := ApdComPort1.AddDataTrigger(LF,false);
  end;

  for I := 0 to 9 do
    ComboBox2.Items.Add(IntToStr(BaudTable[I]));

  ComboBox2.ItemIndex := 5;
  ApdComPort1.Baud := BaudTable[ComboBox2.ItemIndex];


  Verbose1.Checked := false;

end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
var
  TextInBox: string;
  NumInBox: string;
  TheComNum: integer;
begin
  try
    ApdComPort1.RemoveTrigger(LFTrigger);
    ApdComPort1.Open := false;
    TextInBox := ComboBox1.Items[ComboBox1.ItemIndex];
    NumInBox :=  Copy(TextInBox,4,2);
    TheComNum := StrToInt(NumInBox);

    ApdComPort1.ComNumber := TheComNum;
    ApdSLController1.Monitoring := true;
    ApdComPort1.Open := true;
    LFTrigger := ApdComPort1.AddDataTrigger(LF,false);
  except
    on E: Exception do MessageDlg(E.Message, mtError, [mbOK], 0);
  end;
end;

procedure TForm1.ComboBox2Change(Sender: TObject);
begin
  ApdComPort1.Baud := BaudTable[ComboBox2.ItemIndex];
end;

procedure TForm1.ApdComPort1TriggerAvail(CP: TObject; Count: Word);
var
  i : Word;
begin
  for i := 1 to Count do
    RcvBuf := RcvBuf + ApdComPort1.GetChar;
end;

procedure TForm1.ApdComPort1TriggerData(CP: TObject; TriggerHandle: Word);
//var
  //Temp: string;
begin
  if TriggerHandle = LFTrigger then
  begin
    //TempString := Trim(RcvBuf);

    //Temp := CleanString(TempString);
    //if Temp <> '' then
    //begin
      //Temp := Temp + LF;
      //Memo1.Lines.Add(TempString);  // Display the message
    //end;

    //Memo1.Lines.Add(RcvBuf);  // Replaced this with one below
    TempString := Trim(RcvBuf);
    Memo1.Lines.Add(TempString);
    if (Verbose1.Checked = true) then DecodeResponse;
  end;
  RcvBuf := '';
end;

procedure TForm1.ShowDateTime1Click(Sender: TObject);
begin
  ApdComPort1.PutString('a'+LF);
  StatusBar1.Panels[0].Text := '';
end;

procedure TForm1.SetDateTime1Click(Sender: TObject);
var
  CurDate: TDateTime;
  WeekDay: integer;
  MyDate: string;
  DoW: string;
  Month: string;
  Day: string;
  Year: string;
  Time: string;
  Hour: string;
  Minute: string;
  Second: string;
begin
  CurDate := Date;
  WeekDay := DayOfWeek(CurDate);
  DoW := IntToStr(WeekDay);
  if (Length(DoW) < 2) then
    DoW := '0'+DoW;

  MyDate := FormatDateTime('yy/mm/dd', Now);
  Year := GetFirstToken(MyDate,'/');
  MyDate := StripFirstToken(MyDate,'/');
  Month := GetFirstToken(MyDate,'/');
  Day := StripFirstToken(MyDate,'/');

  Time := FormatDateTime('hh:nn:ss', Now);
  Hour := GetFirstToken(Time,':');
  Time := StripFirstToken(Time,':');
  Minute := GetFirstToken(Time,':');
  Second := StripFirstToken(Time,':');

  ApdComPort1.PutString('b,'+Year+','+Month+','+Day+','+DoW+','+Hour+','+Minute+','+Second+LF);
  StatusBar1.Panels[0].Text := 'Date/time set';
end;

procedure TForm1.Clear1Click(Sender: TObject);
begin
  Memo1.Clear;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  if Edit1.Text <> '' then
  begin
     ApdComPort1.PutString(Edit1.Text + CRLF);
     StatusBar1.Panels[0].Text := 'Command sent';
  end
  else
  begin
     StatusBar1.Panels[0].Text := 'Enter command';
  end;
end;

procedure TForm1.Memo1DblClick(Sender: TObject);
begin
  //Edit2.Text := Memo1.SelText;
  StatusBar1.Panels[1].Text := Memo1.SelText;
  StatusBar1.Panels[0].Text := '';
end;

procedure TForm1.GetDir1Click(Sender: TObject);      // Display directory
begin
  ApdComPort1.PutString('x' + CRLF);
  StatusBar1.Panels[1].Text := '';
  StatusBar1.Panels[0].Text := 'Retrieving directory';
end;

procedure TForm1.GetFile1Click(Sender: TObject);     // Display file
begin
  if StatusBar1.Panels[1].Text <> '' then
  begin
    Memo1.Clear;
    ApdComPort1.PutString('y' + StatusBar1.Panels[1].Text + CRLF);
    StatusBar1.Panels[0].Text := 'File retrieved';
  end
  else
  begin
    StatusBar1.Panels[0].Text := 'Select file from directory list';
  end;
end;

procedure TForm1.DeleteFile1Click(Sender: TObject);  // Erase file
begin
  if StatusBar1.Panels[1].Text <> '' then
  begin
    ApdComPort1.PutString('z' + StatusBar1.Panels[1].Text + CRLF);
    StatusBar1.Panels[0].Text := 'File deleted';
  end
  else
  begin
    StatusBar1.Panels[0].Text := 'Select file from directory list';
  end;
end;

procedure TForm1.SetRTCC1Click(Sender: TObject);
var
  CurDate: TDateTime;
  WeekDay: integer;
  MyDate: string;
  DoW: string;
  Month: string;
  Day: string;
  Year: string;
  Time: string;
  Hour: string;
  Minute: string;
  Second: string;
begin
  CurDate := Date;
  WeekDay := DayOfWeek(CurDate);
  DoW := IntToStr(WeekDay);
  if (Length(DoW) < 2) then
    DoW := '0'+DoW;

  MyDate := FormatDateTime('yy/mm/dd', Now);
  Year := GetFirstToken(MyDate,'/');
  MyDate := StripFirstToken(MyDate,'/');
  Month := GetFirstToken(MyDate,'/');
  Day := StripFirstToken(MyDate,'/');

  Time := FormatDateTime('hh:nn:ss', Now);
  Hour := GetFirstToken(Time,':');
  Time := StripFirstToken(Time,':');
  Minute := GetFirstToken(Time,':');
  Second := StripFirstToken(Time,':');

  ApdComPort1.PutString('c,'+Year+','+Month+','+Day+','+DoW+','+Hour+','+Minute+','+Second+LF);
  StatusBar1.Panels[0].Text := 'Real-time-clock set';
end;

procedure TForm1.SetSite1Click(Sender: TObject);
begin
  if StatusBar1.Panels[1].Text <> '' then
  begin
    if (Length(StatusBar1.Panels[1].Text) > 27) then
    begin
        StatusBar1.Panels[0].Text := 'Site text is too long';
    end
    else
    begin
        ApdComPort1.PutString('u' + StatusBar1.Panels[1].Text + CRLF);
        StatusBar1.Panels[0].Text := 'Site location sent';
    end;
  end
  else
  begin
    StatusBar1.Panels[0].Text := 'Enter a site location';
  end;
end;

procedure TForm1.SetSelectionClick(Sender: TObject);
begin
  StatusBar1.Panels[1].Text := Memo1.SelText;
  StatusBar1.Panels[0].Text := '';
end;

procedure TForm1.SaveAs1Click(Sender: TObject);
var
  CurrentDir  : string;
  CurrentFile: string;
  SaveFile: TextFile;
begin
  GetDir(0,CurrentDir);
  SaveDialog1.InitialDir := CurrentDir;

  if SaveDialog1.Execute then
  begin
    CurrentFile := SaveDialog1.Filename;
    if Memo1.Lines.Count > 0 then
    begin
      AssignFile(SaveFile, CurrentFile);
      Memo1.Lines.SaveToFile(CurrentFile);
    end;
  end; {if SaveDialog1.Execute}
end;


//******************************************************************************

{ Suppres the sending of default information packets }
procedure TForm1.SetOutput1Click(Sender: TObject);
const
  Disable: string = '$PMTK314,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0*';
begin
  SendToGPS(Disable);
  //Verbose := true;
end;

{ Check the setting of output packet enable flags }
procedure TForm1.QueryOutput1Click(Sender: TObject);
const
  Query: string = '$PMTK414*';
begin
  SendToGPS(Query);
end;

{ Request GLL message }
procedure TForm1.QueryGLL1Click(Sender: TObject);
const
  GLL_Command: string = '$PMTK448,1*';
begin
  SendToGPS(GLL_Command);
end;

{ Request RMC message }
procedure TForm1.QueryRMC1Click(Sender: TObject);
const
  RMC_Command: string = '$PMTK448,2*';
begin
  SendToGPS(RMC_Command);
end;

{ Request VTG message }
procedure TForm1.QueryVTG1Click(Sender: TObject);
const
  VTG_Command: string = '$PMTK448,3*';
begin
  SendToGPS(VTG_Command);
end;

{ Request GGA message }
procedure TForm1.QueryGGA1Click(Sender: TObject);
const
  GGA_Command: string = '$PMTK448,4*';
begin
  SendToGPS(GGA_Command);
end;

{ Request GSA message }
procedure TForm1.QueryGSA1Click(Sender: TObject);
const
  GSA_Command: string = '$PMTK448,5*';
begin
  SendToGPS(GSA_Command);
end;

{ Request GSV message }
procedure TForm1.QueryGSV1Click(Sender: TObject);
const
  GSV_Command: string = '$PMTK448,6*';
begin
  SendToGPS(GSV_Command);
end;

{ Request ZDA message }
procedure TForm1.QueryZDA1Click(Sender: TObject);
const
  ZDA_Command: string = '$PMTK448,7*';
begin
  SendToGPS(ZDA_Command);
end;

procedure TForm1.Verbose1Click(Sender: TObject);
begin
  if (Verbose1.Checked) then
  begin
    Verbose1.Checked := false;
  end
  else
  begin
    Verbose1.Checked := true;
  end;
end;

procedure TForm1.SetExternalRTC1Click(Sender: TObject);
var
  CurDate: TDateTime;
  WeekDay: integer;
  MyDate: string;
  DoW: string;
  Month: string;
  Day: string;
  Year: string;
  Time: string;
  Hour: string;
  Minute: string;
  Second: string;
begin
  CurDate := Date;
  WeekDay := DayOfWeek(CurDate);
  DoW := IntToStr(WeekDay);
  if (Length(DoW) < 2) then
    DoW := '0'+DoW;

  MyDate := FormatDateTime('yy/mm/dd', Now);
  Year := GetFirstToken(MyDate,'/');
  MyDate := StripFirstToken(MyDate,'/');
  Month := GetFirstToken(MyDate,'/');
  Day := StripFirstToken(MyDate,'/');

  Time := FormatDateTime('hh:nn:ss', Now);
  Hour := GetFirstToken(Time,':');
  Time := StripFirstToken(Time,':');
  Minute := GetFirstToken(Time,':');
  Second := StripFirstToken(Time,':');

  ApdComPort1.PutString('q,'+Year+','+Month+','+Day+','+DoW+','+Hour+','+Minute+','+Second+LF);
  StatusBar1.Panels[0].Text := 'Real-time-clock set';
end;

procedure TForm1.ReadExternalRTC1Click(Sender: TObject);
begin
  ApdComPort1.PutString('p'+LF);
  StatusBar1.Panels[0].Text := '';
end;

end.
